//=======================================================================
//  TARGET PROJECT: PSM3D(Prosessor Study Model3 DualCore)
//  TARGET SYSTEM : DEMO on Sp3StarterKit (PSM3D TARGET SYSTEM)
//  FUNCTION      : HW Description
//
//                      Copyright (C) 2010 by Tomoyuki Inomoto
//=======================================================================
//============ IRQ CTRL =====================================
#define         REG_IRQ0_MASK       (0x0C000000)
#define         REG_IRQ0_STAT       (0x0C000004)
#define         REG_IRQ0_CREAR      (0x0C000008)
#define         REG_IRQ0_SET        (0x0C00000C)

#define         REG_IRQ1_MASK       (0x0C000010)
#define         REG_IRQ1_STAT       (0x0C000014)
#define         REG_IRQ1_CREAR      (0x0C000018)
#define         REG_IRQ1_SET        (0x0C00001C)

#define         BIT_IRQ_TIMER0      (0x00000001)
#define         BIT_IRQ_TIMER1      (0x00000002)
#define         BIT_IRQ_UART_S      (0x00000004)
#define         BIT_IRQ_UART_R      (0x00000008)
#define         BIT_IRQ_SOFT0       (0x00000010)
#define         BIT_IRQ_SOFT1       (0x00000020)


#define         NUM_IRQ_TIMER0      (0)
#define         NUM_IRQ_TIMER1      (1)
#define         NUM_IRQ_UART_S      (2)
#define         NUM_IRQ_UART_R      (3)
#define         NUM_IRQ_SOFT0       (4)
#define         NUM_IRQ_SOFT1       (5)

//============ TIMER =====================================
#define         REG_TM0_CTRL        (0x0C000020)
#define         REG_TM0_PERIOD      (0x0C000024)
#define         REG_TM0_CURRENT     (0x0C000028)

#define         REG_TM1_CTRL        (0x0C000030)
#define         REG_TM1_PERIOD      (0x0C000034)
#define         REG_TM1_CURRENT     (0x0C000038)

#define         BIT_TM_STOP         (0)
#define         BIT_TM_RUN          (1)

//============ GPIO =====================================
#define         REG_GPIO_SWITCH     (0x0C000040)
//                  bit10 :rotary B
//                  bit9  :rotary A
//                  bit8  :rotary push
//                  bit7-4:push sw
//                  bit3-0:slide sw

#define         REG_GPIO_LED        (0x0C000044)
//                  bit14  :LCD_RW
//                  bit13  :LCD_E
//                  bit12  :LCD_RS
//                  bit11-8:LCD_DB[7:4]
//                  bit7-0 :LED[7:0]

#define         REG_GPIO_IO_MODE    (0x0C000048)
#define         REG_GPIO_IO_DATA    (0x0C00004C)

//============ UART =====================================
#define         REG_UART_CTRL       (0x0C000050)
#define         REG_UART_SDATA      (0x0C000054)
#define         REG_UART_RDATA      (0x0C000058)

#define         BIT_UART_RFIFO_EMPTY    (0x00000001)
#define         BIT_UART_RFIFO_AFULL    (0x00000002)
#define         BIT_UART_RFIFO_FULL     (0x00000004)
#define         BIT_UART_SFIFO_EMPTY    (0x00000008)
#define         BIT_UART_SFIFO_FULL     (0x00000010)
#define         BIT_UART_SPEED_BIT      (0x00000700)
#define         BIT_UART_SPEED_9K6      (0x00000400)
#define         BIT_UART_SPEED_19K2     (0x00000300)
#define         BIT_UART_SPEED_38K4     (0x00000200)
#define         BIT_UART_SPEED_56K      (0x00000100)
#define         BIT_UART_SPEED_115K2    (0x00000000)

//============ VGA =====================================
#define         REG_VGA_CTRL        (0x0C000060)
#define         REG_VGA_LAYER0_BASE (0x0C000064)
#define         REG_VGA_LAYER1_BASE (0x0C000068)

#define         BIT_VGA_STOP        (0x00000000)
#define         BIT_VGA_RUN         (0x00000001)
#define         BIT_VGA_MIX_OW      (0x00000000)
#define         BIT_VGA_MIX_XOR     (0x00000002)

//============ OCM =====================================
#define         OCM_BASE_ADR        (0x0C008000)
#define         OCM_SIZE            (2048)
