//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  TARGET SYSTEM : Psm3Sys (PSM3 TEST SYSTEM)
//  FUNCTION      : Bus Splitter for Inst Bus
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================
module BusSplit1(
    //======== SYSTEM ==============
    MemMapMode      ,

    //======= Master Bus ================
    MstrCRQ         ,
    MstrCAK         ,
    MstrBRST        ,
    MstrADR         ,
    MstrRD          ,
    MstrRDAK        ,

    //======= Flash Bus ================
    FlashCRQ        ,
    FlashCAK        ,
    FlashBRST       ,
    FlashADR        ,
    FlashRD         ,
    FlashRDAK       ,

    //======= Ddr Bus ================
    DdrCRQ          ,
    DdrCAK          ,
    DdrBRST         ,
    DdrADR          ,
    DdrRD           ,
    DdrRDAK
);
    //==================================================
    //======== port  ===================================
    //==================================================
    //======== SYSTEM ==============
    input           MemMapMode      ; // 0: DDR, 1:Flash

    //======= Master Bus ================
    input           MstrCRQ         ;
    output          MstrCAK         ;
    input           MstrBRST        ;
    input   [25:0]  MstrADR         ;
    output  [31:0]  MstrRD          ;
    output          MstrRDAK        ;

    //======= Flash Bus ================
    output          FlashCRQ        ;
    input           FlashCAK        ;
    output          FlashBRST       ;
    output  [25:0]  FlashADR        ;
    input   [31:0]  FlashRD         ;
    input           FlashRDAK       ;

    //======= Ddr Bus ================
    output          DdrCRQ          ;
    input           DdrCAK          ;
    output          DdrBRST         ;
    output  [25:0]  DdrADR          ;
    input   [31:0]  DdrRD           ;
    input           DdrRDAK         ;

    //==================================================
    //======== wire & reg ==============================
    //==================================================
    //====================================================================
    //======== BODY ======================================================
    //====================================================================

    //======= Master Bus ================
    //assign  MstrCAK  = FlashCAK | DdrCAK;
    //assign  MstrRD  = (~MemMapMode)? DdrRD : FlashRD;
    //assign  MstrRDAK  = FlashRDAK | DdrRDAK;
    assign  MstrCAK  = DdrCAK;
    assign  MstrRD   = DdrRD;
    assign  MstrRDAK = DdrRDAK;

    //======= Flash Bus ================
    //assign  FlashCRQ  = MstrCRQ & MemMapMode;
    //assign  FlashBRST  = MstrBRST;
    //assign  FlashADR = MstrADR[25:0];

    assign  FlashCRQ  = 1'b0;
    assign  FlashBRST = 1'b0;
    assign  FlashADR = 26'h0;

    //======= Ddr Bus ================
    //assign  DdrCRQ  = MstrCRQ & ~MemMapMode;
    assign  DdrCRQ  = MstrCRQ;
    assign  DdrBRST = MstrBRST;
    assign  DdrADR = MstrADR[25:0];

endmodule
