//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  TARGET SYSTEM : Psm3Sys (PSM3 TEST SYSTEM)
//  FUNCTION      : DDR-SDRAM I/F Top Module
//  VERSION       : Ver0.70
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================

module DdrIfTop(
    //======== SYSTEM ==============
    Clk             ,
    DdrClk          ,
    DdrClkP270      ,
    RstN            ,
    DdrRstN         ,

    //======= Master0 Bus[Read:32bit/Write:32bit] ================
    Mstr0CRQ        ,
    Mstr0CAK        ,
    Mstr0BRST       ,
    Mstr0RW         ,
    Mstr0BE         ,
    Mstr0ADR        ,
    Mstr0WD         ,
    Mstr0WDAK       ,
    Mstr0RD         ,
    Mstr0RDAK       ,

    //======= Master1 Bus[Read:32bit/Write:32bit] ================
    Mstr1CRQ        ,
    Mstr1CAK        ,
    Mstr1BRST       ,
    Mstr1RW         ,
    Mstr1BE         ,
    Mstr1ADR        ,
    Mstr1WD         ,
    Mstr1WDAK       ,
    Mstr1RD         ,
    Mstr1RDAK       ,

    //======= Master2 Bus[Read:32bit/Write:32bit] ================
    Mstr2CRQ        ,
    Mstr2CAK        ,
    Mstr2BRST       ,
    Mstr2RW         ,
    Mstr2BE         ,
    Mstr2ADR        ,
    Mstr2WD         ,
    Mstr2WDAK       ,
    Mstr2RD         ,
    Mstr2RDAK       ,

    //======= Master3 Bus[Read:32bit/Write:32bit] ================
    Mstr3CRQ        ,
    Mstr3CAK        ,
    Mstr3BRST       ,
    Mstr3RW         ,
    Mstr3BE         ,
    Mstr3ADR        ,
    Mstr3WD         ,
    Mstr3WDAK       ,
    Mstr3RD         ,
    Mstr3RDAK       ,

    //======= Master4 Bus[Read:32bit/Write:32bit] ================
    Mstr4CRQ        ,
    Mstr4CAK        ,
    Mstr4BRST       ,
    Mstr4RW         ,
    Mstr4BE         ,
    Mstr4ADR        ,
    Mstr4WD         ,
    Mstr4WDAK       ,
    Mstr4RD         ,
    Mstr4RDAK       ,

    //======= Master5 Bus[Read:32bit/Write:32bit] ================
    Mstr5CRQ        ,
    Mstr5CAK        ,
    Mstr5BRST       ,
    Mstr5RW         ,
    Mstr5BE         ,
    Mstr5ADR        ,
    Mstr5WD         ,
    Mstr5WDAK       ,
    Mstr5RD         ,
    Mstr5RDAK       ,

    //======== SYSTEM ==============
    DDRCK           ,
    DDRNCK          ,
    DDRCKE          ,
    DDRNCS          ,
    DDRRAS          ,
    DDRCAS          ,
    DDRNWE          ,
    DDRBA           ,
    DDRA            ,
    DDRDQS          ,
    DDRDM           ,
    DDRDQ

);
    //==================================================
    //======== port  ===================================
    //==================================================
    //======== SYSTEM ==============
    input           Clk             ;
    input           DdrClk          ;
    input           DdrClkP270      ;
    input           RstN            ;
    input           DdrRstN         ;

    //======= Master0 Bus[Read:32bit/Write:32bit] ================
    input           Mstr0CRQ        ;
    output          Mstr0CAK        ;
    input           Mstr0BRST       ;
    input           Mstr0RW         ;
    input   [3:0]   Mstr0BE         ;
    input   [25:2]  Mstr0ADR        ;
    input   [31:0]  Mstr0WD         ;
    output          Mstr0WDAK       ;
    output  [31:0]  Mstr0RD         ;
    output          Mstr0RDAK       ;

    //======= Master1 Bus[Read:32bit/Write:32bit] ================
    input           Mstr1CRQ        ;
    output          Mstr1CAK        ;
    input           Mstr1BRST       ;
    input           Mstr1RW         ;
    input   [3:0]   Mstr1BE         ;
    input   [25:2]  Mstr1ADR        ;
    input   [31:0]  Mstr1WD         ;
    output          Mstr1WDAK       ;
    output  [31:0]  Mstr1RD         ;
    output          Mstr1RDAK       ;

    //======= Master2 Bus[Read:32bit/Write:32bit] ================
    input           Mstr2CRQ        ;
    output          Mstr2CAK        ;
    input           Mstr2BRST       ;
    input           Mstr2RW         ;
    input   [3:0]   Mstr2BE         ;
    input   [25:2]  Mstr2ADR        ;
    input   [31:0]  Mstr2WD         ;
    output          Mstr2WDAK       ;
    output  [31:0]  Mstr2RD         ;
    output          Mstr2RDAK       ;

    //======= Master3 Bus[Read:32bit/Write:32bit] ================
    input           Mstr3CRQ        ;
    output          Mstr3CAK        ;
    input           Mstr3BRST       ;
    input           Mstr3RW         ;
    input   [3:0]   Mstr3BE         ;
    input   [25:2]  Mstr3ADR        ;
    input   [31:0]  Mstr3WD         ;
    output          Mstr3WDAK       ;
    output  [31:0]  Mstr3RD         ;
    output          Mstr3RDAK       ;

    //======= Master4 Bus[Read:32bit/Write:32bit] ================
    input           Mstr4CRQ        ;
    output          Mstr4CAK        ;
    input           Mstr4BRST       ;
    input           Mstr4RW         ;
    input   [3:0]   Mstr4BE         ;
    input   [25:2]  Mstr4ADR        ;
    input   [31:0]  Mstr4WD         ;
    output          Mstr4WDAK       ;
    output  [31:0]  Mstr4RD         ;
    output          Mstr4RDAK       ;

    //======= Master5 Bus[Read:32bit/Write:32bit] ================
    input           Mstr5CRQ        ;
    output          Mstr5CAK        ;
    input           Mstr5BRST       ;
    input           Mstr5RW         ;
    input   [3:0]   Mstr5BE         ;
    input   [25:2]  Mstr5ADR        ;
    input   [31:0]  Mstr5WD         ;
    output          Mstr5WDAK       ;
    output  [31:0]  Mstr5RD         ;
    output          Mstr5RDAK       ;

    //======== DDR-SDRAM ==============
    output          DDRCK           ;
    output          DDRNCK          ;
    output          DDRCKE          ;
    output          DDRNCS          ;
    output          DDRRAS          ;
    output          DDRCAS          ;
    output          DDRNWE          ;
    output  [1:0]   DDRBA           ;
    output  [12:0]  DDRA            ;
    output  [1:0]   DDRDQS          ;
    output  [1:0]   DDRDM           ;
    inout   [15:0]  DDRDQ           ;

    //==================================================
    //======== wire & reg ==============================
    //==================================================
    wire            DdrComFifoFull  ;
    wire            DdrComFifoEmpty ;
    wire            DdrComFifoEmpty3;
    wire            DdrComFifoWe    ;
    wire            DdrComFifoRe    ;

    wire    [5:0]   FiComMstr       ;
    wire            FiDdrBRST       ;
    wire            FiDdrRW         ;
    wire    [3:0]   FiDdrBE         ;
    wire    [25:2]  FiDdrADR        ;
    wire    [31:0]  FiDdrWD         ;

    wire    [5:0]   FoComMstr       ;
    wire            FoDdrBRST       ;
    wire            FoDdrRW         ;
    wire    [3:0]   FoDdrBE         ;
    wire    [25:2]  FoDdrADR        ;
    wire    [31:0]  FoDdrWD         ;

    wire            DdrRdFifoEmpty  ;
    wire            DdrRdFifoRe     ;
    wire            DdrRdFifoWe     ;
    wire    [5:0]   FiRDMstr        ;
    wire    [31:0]  FiDdrRD         ;
    wire    [5:0]   FoRDMstr        ;
    wire    [31:0]  FoDdrRD         ;

    //====================================================================
    //======== BODY ======================================================
    //====================================================================

    DdrAbt DdrAbt(
        .Clk             ( Clk              ),
        .RstN            ( RstN             ),

        .Mstr0CRQ        ( Mstr0CRQ         ),
        .Mstr0CAK        ( Mstr0CAK         ),
        .Mstr0BRST       ( Mstr0BRST        ),
        .Mstr0RW         ( Mstr0RW          ),
        .Mstr0BE         ( Mstr0BE          ),
        .Mstr0ADR        ( Mstr0ADR         ),
        .Mstr0WD         ( Mstr0WD          ),
        .Mstr0WDAK       ( Mstr0WDAK        ),
        .Mstr0RD         ( Mstr0RD          ),
        .Mstr0RDAK       ( Mstr0RDAK        ),

        .Mstr1CRQ        ( Mstr1CRQ         ),
        .Mstr1CAK        ( Mstr1CAK         ),
        .Mstr1BRST       ( Mstr1BRST        ),
        .Mstr1RW         ( Mstr1RW          ),
        .Mstr1BE         ( Mstr1BE          ),
        .Mstr1ADR        ( Mstr1ADR         ),
        .Mstr1WD         ( Mstr1WD          ),
        .Mstr1WDAK       ( Mstr1WDAK        ),
        .Mstr1RD         ( Mstr1RD          ),
        .Mstr1RDAK       ( Mstr1RDAK        ),

        .Mstr2CRQ        ( Mstr2CRQ         ),
        .Mstr2CAK        ( Mstr2CAK         ),
        .Mstr2BRST       ( Mstr2BRST        ),
        .Mstr2RW         ( Mstr2RW          ),
        .Mstr2BE         ( Mstr2BE          ),
        .Mstr2ADR        ( Mstr2ADR         ),
        .Mstr2WD         ( Mstr2WD          ),
        .Mstr2WDAK       ( Mstr2WDAK        ),
        .Mstr2RD         ( Mstr2RD          ),
        .Mstr2RDAK       ( Mstr2RDAK        ),

        .Mstr3CRQ        ( Mstr3CRQ         ),
        .Mstr3CAK        ( Mstr3CAK         ),
        .Mstr3BRST       ( Mstr3BRST        ),
        .Mstr3RW         ( Mstr3RW          ),
        .Mstr3BE         ( Mstr3BE          ),
        .Mstr3ADR        ( Mstr3ADR         ),
        .Mstr3WD         ( Mstr3WD          ),
        .Mstr3WDAK       ( Mstr3WDAK        ),
        .Mstr3RD         ( Mstr3RD          ),
        .Mstr3RDAK       ( Mstr3RDAK        ),

        .Mstr4CRQ        ( Mstr4CRQ         ),
        .Mstr4CAK        ( Mstr4CAK         ),
        .Mstr4BRST       ( Mstr4BRST        ),
        .Mstr4RW         ( Mstr4RW          ),
        .Mstr4BE         ( Mstr4BE          ),
        .Mstr4ADR        ( Mstr4ADR         ),
        .Mstr4WD         ( Mstr4WD          ),
        .Mstr4WDAK       ( Mstr4WDAK        ),
        .Mstr4RD         ( Mstr4RD          ),
        .Mstr4RDAK       ( Mstr4RDAK        ),

        .Mstr5CRQ        ( Mstr5CRQ         ),
        .Mstr5CAK        ( Mstr5CAK         ),
        .Mstr5BRST       ( Mstr5BRST        ),
        .Mstr5RW         ( Mstr5RW          ),
        .Mstr5BE         ( Mstr5BE          ),
        .Mstr5ADR        ( Mstr5ADR         ),
        .Mstr5WD         ( Mstr5WD          ),
        .Mstr5WDAK       ( Mstr5WDAK        ),
        .Mstr5RD         ( Mstr5RD          ),
        .Mstr5RDAK       ( Mstr5RDAK        ),

        .DdrComFifoFull  ( DdrComFifoFull   ),
        .DdrComFifoWe    ( DdrComFifoWe     ),
        .DdrComMstr      ( FiComMstr        ),
        .DdrBRST         ( FiDdrBRST        ),
        .DdrRW           ( FiDdrRW          ),
        .DdrBE           ( FiDdrBE          ),
        .DdrADR          ( FiDdrADR         ),
        .DdrWD           ( FiDdrWD          ),

        .DdrRdFifoEmpty  ( DdrRdFifoEmpty   ),
        .DdrRdFifoRe     ( DdrRdFifoRe      ),
        .DdrRDMstr       ( FoRDMstr         ),
        .DdrRD           ( FoDdrRD          )
    );
    Fifo68bx16w DdrComFifo(
        .din        ( {FiComMstr, FiDdrBRST, FiDdrRW, FiDdrADR, FiDdrBE, FiDdrWD} ),
        .rd_clk     ( DdrClk            ),
        .rd_en      ( DdrComFifoRe      ),
        .rst        ( ~RstN             ),
        .wr_clk     ( Clk               ),
        .wr_en      ( DdrComFifoWe      ),
        .dout       ( {FoComMstr, FoDdrBRST, FoDdrRW, FoDdrADR, FoDdrBE, FoDdrWD} ),
        .empty      ( DdrComFifoEmpty   ),
        .full       (                   ),
        .prog_empty ( DdrComFifoEmpty3  ),
        .prog_full  ( DdrComFifoFull    )
    );

    Fifo38bx16w DdrRdFifo(
        .din        ( {FiRDMstr, FiDdrRD} ),
        .rd_clk     ( Clk                 ),
        .rd_en      ( DdrRdFifoRe         ),
        .rst        ( ~RstN               ),
        .wr_clk     ( DdrClk              ),
        .wr_en      ( DdrRdFifoWe         ),
        .dout       ( {FoRDMstr, FoDdrRD} ),
        .empty      ( DdrRdFifoEmpty      ),
        .full       (                     )
    );

    DdrIf DdrIf(
        .DdrClk          ( DdrClk           ),
        .DdrClkP270      ( DdrClkP270       ),
        .RstN            ( DdrRstN          ),

        .DdrComFifoEmpty ( DdrComFifoEmpty  ),
        .DdrComFifoEmpty3( DdrComFifoEmpty3 ),
        .DdrComFifoRe    ( DdrComFifoRe     ),
        .DdrComMstr      ( FoComMstr        ),
        .DdrBRST         ( FoDdrBRST        ),
        .DdrRW           ( FoDdrRW          ),
        .DdrBE           ( FoDdrBE          ),
        .DdrADR          ( FoDdrADR         ),
        .DdrWD           ( FoDdrWD          ),

        .DdrRdFifoWe     ( DdrRdFifoWe      ),
        .DdrRDMstr       ( FiRDMstr         ),
        .DdrRD           ( FiDdrRD          ),

        .DDRCK           ( DDRCK            ),
        .DDRNCK          ( DDRNCK           ),
        .DDRCKE          ( DDRCKE           ),
        .DDRNCS          ( DDRNCS           ),
        .DDRRAS          ( DDRRAS           ),
        .DDRCAS          ( DDRCAS           ),
        .DDRNWE          ( DDRNWE           ),
        .DDRBA           ( DDRBA            ),
        .DDRA            ( DDRA             ),
        .DDRDQS          ( DDRDQS           ),
        .DDRDM           ( DDRDM            ),
        .DDRDQ           ( DDRDQ            )
    );

endmodule
