/*=======================================================================*
//  TARGET PROJECT: PSM3(Prosessor Study Model3)                         
//  TARGET SYSTEM : *(PSM3 TARGET SYSTEM)                                
//  FUNCTION      : Top Module of Psm3DualCoreSystem                     
//
//                      Copyright (C) 2008-2010 by Tomoyuki Inomoto
 *=======================================================================*/
// 20100529:Cash->Cache (spell miss)
//=======================================================================

module P3dSysTop(
    //======== SYSTEM ========================
    CK50M           ,
    CLK_AUX         ,
    CLK_SMA         ,

    //======= GPIO ========================
    SlideSW         ,
    PushSW          ,
    RotCenter       ,
    RotA            ,
    RotB            ,

    LcdE            ,
    LcdRS           ,
    LcdRW           ,
    LED             ,

    //======= VGA ========================
    VS              ,
    HS              ,
    VR              ,
    VG              ,
    VB              ,

    //======== UART ===================
    TxD0            ,
    RxD0            ,
    TxD1            ,
    RxD1            ,

    //======== PS2 ===================
    PS2_CLK         ,
    PS2_DATA        ,

    //======= SPI(ADC/DAC/AMP) =========
    //SPI_MISO      ,
    SPI_MOSI        ,
    SPI_SCK         ,
    SPI_ALT_CS_JP11 ,
    SPI_SS_B        ,
    DAC_CS          ,
    DAC_CLR         ,
    AMP_CS          ,
    AD_CONV         ,
    AMP_DOUT        ,
    AMP_SHDN        ,

    //======== FLASH ==============
    SF_CE0          ,
    SF_OE           ,
    SF_WE           ,
    SF_BYTE         ,
    SF_A            ,
    SF_D            ,
    SF_STS          ,

    //======== DDR-SDRAM ==============
    DDRCK           ,
    DDRNCK          ,
    DDRCKE          ,
    DDRNCS          ,
    DDRRAS          ,
    DDRCAS          ,
    DDRNWE          ,
    DDRBA           ,
    DDRA            ,
    DDRDQS          ,
    DDRDM           ,
    DDRDQ           ,
    SD_CK_FB        ,

    //======== EthPhy ==============
    E_COL           ,
    E_CRS           ,
    E_MDC           ,
    E_MDIO          ,
    E_RX_CLK        ,
    E_RX_DV         ,
    E_RXD           ,
    E_TX_CLK        ,
    E_TX_EN         ,
    E_TXD           ,


    //======== FX2 ==============
    FX2_IO1         ,
    FX2_IO2         ,
    FX2_IO3         ,
    FX2_IO4         ,
    FX2_IO5         ,
    FX2_IO6         ,
    FX2_IO7         ,
    FX2_IO8         ,
    FX2_IO9         ,
    FX2_IO10        ,
    FX2_IO11        ,
    FX2_IO12        ,
    FX2_IO21        ,
    FX2_IO22        ,
    FX2_IO23        ,
    FX2_IO24        ,
    FX2_IO25        ,
    FX2_IO26        ,
    FX2_IO27        ,
    FX2_IO28        ,
    FX2_IO29        ,
    FX2_IO30        ,
    FX2_IO31        ,
    FX2_IO32        ,
    FX2_IO33        ,
    FX2_IO34        ,
    FX2_IP35        ,
    FX2_IP36        ,
    FX2_IP37        ,
    FX2_IP38        ,
    FX2_IO39        ,
    FX2_IP40        ,
    FX2_CLKIN       ,
    FX2_CLKOUT      ,
    FX2_CLKIO       ,

    //======== CoolRunner2 ================
    XC_CMD          ,
    XC_CPLD_EN      ,
    XC_D            ,
    XC_TRIG         ,
    XC_GCK0         ,

    //======== DS2432 ================
    DS_WIRE
);
    //============================================================
    //======== port  =============================================
    //============================================================
    //======== SYSTEM ========================
    input           CK50M           ; // Clock Input(50MHz)
                                      // RESET : PushSW[2] (SOUTH)
    input           CLK_AUX         ; // RESERVE
    input           CLK_SMA         ; // RESERVE

    //======= GPIO ===================
    input   [3:0]   SlideSW         ;
    input   [3:0]   PushSW          ;  //[3]:NOTH, [2]:SOUTH(RESET), [1]:EAST, [0]:WEST
    input           RotCenter       ;
    input           RotA            ;
    input           RotB            ;

    output          LcdE            ;
    output          LcdRS           ;
    output          LcdRW           ;
    //output  [7:4]   LcdDB           ;
    output  [7:0]   LED             ;

    //======= VGA ========================
    output          VS              ;
    output          HS              ;
    output          VR              ;
    output          VG              ;
    output          VB              ;

    //======== UART ===================
    output          TxD0            ;
    input           RxD0            ;
    output          TxD1            ;
    input           RxD1            ;

    //======== PS2 ===================
    input           PS2_CLK         ;
    input           PS2_DATA        ;

    //======= SPI(ADC/DAC/AMP) =========
    //input           SPI_MISO        ; // SF_D[0]
    output          SPI_MOSI        ;
    output          SPI_SCK         ;
    input           SPI_ALT_CS_JP11 ;
    input           SPI_SS_B        ;
    output          DAC_CS          ;
    output          DAC_CLR         ;
    output          AMP_CS          ;
    output          AD_CONV         ;
    input           AMP_DOUT        ;
    output          AMP_SHDN        ;

    //======== FLASH ==============
    output          SF_CE0          ;
    output          SF_OE           ;
    output          SF_WE           ;
    output          SF_BYTE         ;
    output  [23:0]  SF_A            ;
    inout   [15:0]  SF_D            ;
    input           SF_STS          ;

    //======== DDR-SDRAM ==============
    output          DDRCK           ;
    output          DDRNCK          ;
    output          DDRCKE          ;
    output          DDRNCS          ;
    output          DDRRAS          ;
    output          DDRCAS          ;
    output          DDRNWE          ;
    output  [1:0]   DDRBA           ;
    output  [12:0]  DDRA            ;
    output  [1:0]   DDRDQS          ;
    output  [1:0]   DDRDM           ;
    inout   [15:0]  DDRDQ           ;
    input           SD_CK_FB        ; // Not Use

    //======== EthPhy ==============
    input           E_COL           ;
    input           E_CRS           ;
    output          E_MDC           ;
    input           E_MDIO          ; // inout
    input           E_RX_CLK        ;
    input           E_RX_DV         ;
    input   [4:0]   E_RXD           ;
    input           E_TX_CLK        ;
    output          E_TX_EN         ;
    output  [4:0]   E_TXD           ;


    //======== FX2 ==============
    inout           FX2_IO1         ;
    inout           FX2_IO2         ;
    inout           FX2_IO3         ;
    inout           FX2_IO4         ;
    inout           FX2_IO5         ;
    inout           FX2_IO6         ;
    inout           FX2_IO7         ;
    inout           FX2_IO8         ;
    inout           FX2_IO9         ;
    inout           FX2_IO10        ;
    inout           FX2_IO11        ;
    inout           FX2_IO12        ;

    input           FX2_IO21        ;
    input           FX2_IO22        ;
    input           FX2_IO23        ;
    input           FX2_IO24        ;
    input           FX2_IO25        ;
    input           FX2_IO26        ;
    input           FX2_IO27        ;
    input           FX2_IO28        ;
    input           FX2_IO29        ;
    input           FX2_IO30        ;
    input           FX2_IO31        ;
    input           FX2_IO32        ;
    input           FX2_IO33        ;
    input           FX2_IO34        ;
    input           FX2_IP35        ;
    input           FX2_IP36        ;
    input           FX2_IP37        ;
    input           FX2_IP38        ;
    input           FX2_IO39        ;
    input           FX2_IP40        ;
    input           FX2_CLKIN       ;
    input           FX2_CLKOUT      ;
    output          FX2_CLKIO       ;

    //======== CoolRunner2 ================
    output  [1:0]   XC_CMD          ;
    output          XC_CPLD_EN      ;
    output  [2:0]   XC_D            ;
    input           XC_TRIG         ;
    output          XC_GCK0         ;

    //======== DS2432 ================
    input           DS_WIRE         ; // inout OneWirePROM

    //============================================================
    //======== wire & reg ========================================
    //============================================================
    //======== CLOCK & RESET ===========================================
    wire            RESET           ; // Reset (H-Active)
    wire            Clk             ; // Master Clock (70MHz)
    wire            Clk100m         ; // Ddr Masr Clock (100MHz)
    wire            Clk100mP270     ; // Ddr Masr Clock (100MHz P270)
    wire            RstN            ; // Master Reset
    wire            DdrRstN         ; // Ddr Reset
    wire            Clk16x230k4     ; // for uart 230400x16Hz (On Chip Debugger)
    wire            Clk16x115k2     ; // for uart 115200x16Hz
    wire            Clk16x56k       ; // for uart  56000x16Hz
    wire            Clk16x38k4      ; // for uart  38400x16Hz
    wire            Clk16x19k2      ; // for uart  19200x16Hz
    wire            Clk16x9k6       ; // for uart   9600x16Hz

    //======== Serial Port ================================================
    wire            OcdTxD          ;
    wire            OcdRxD          ;
    wire            UartTxD         ;
    wire            UartRxD         ;

    //======== PSM3 P0===================================================
    wire            IrqOut0         ; // Interrupt Reqest

    wire            P0InstCRQ       ; // INSTRUCTION BUS COMMAND REQ
    wire            P0InstCAK       ; // INSTRUCTION BUS COMMAND ACK
    wire            P0InstBRST      ; // INSTRUCTION BUS SINGLE/BURST
    wire    [25:0]  P0InstADR       ; // INSTRUCTION BUS ADDRESS
    wire    [31:0]  P0InstRD        ; // INSTRUCTION BUS READ DATA
    wire            P0InstRDAK      ; // INSTRUCTION BUS READ DATA ACK

    wire            P0DataCRQ       ; // DATA BUS COMMAND REQ
    wire            P0DataCAK       ; // DATA BUS COMMAND ACK
    wire            P0DataBRST      ; // DATA BUS SINGLE/BURST
    wire            P0DataRW        ; // DATA BUS READ/WRITE (1:WRITE)
    wire    [3:0]   P0DataBE        ; // DATA BUS BYTE ENABLE
    wire    [27:0]  P0DataADR       ; // DATA BUS ADDRESS
    wire    [31:0]  P0DataWD        ; // DATA BUS WRITE DATA
    wire            P0DataWDAK      ; // DATA BUS WRITE DATA ACK
    wire    [31:0]  P0DataRD        ; // DATA BUS READ DATA
    wire            P0DataRDAK      ; // DATA BUS READ DATA ACK

    wire            P0Break         ; // BREAK Instruction Detect Signal to Debugger
    wire            P0DbgRq         ; // Debug Reqest from Debugger
    wire            P0DbgRegRq      ; // Debug Reg Access Request from Debugger
    wire            P0DbgEna        ; // Debug Enable to Debugger
    wire            P0DecInstAK     ; // Ack of Instruction Reqest to DECU
    wire            P0Bubble        ; // Bubble
    wire            P0DbgRWe        ; // Register Write Enable from Debugger
    wire    [31:0]  P0DbgRD         ; // Register Read  Data to   Debugger

    wire            P0CoreGoAhead   ;
    wire            P0CoreInstRQ    ;
    wire            P0CoreInstAK    ;
    wire            P0CoreInstHit   ;
    wire            P0CoreDataRQ    ;
    wire            P0CoreDataAK    ;
    wire            P0CoreDataHit   ;

    //======== PSM3 P0===================================================
    wire            IrqOut1         ; // Interrupt Reqest

    wire            P1InstCRQ       ; // INSTRUCTION BUS COMMAND REQ
    wire            P1InstCAK       ; // INSTRUCTION BUS COMMAND ACK
    wire            P1InstBRST      ; // INSTRUCTION BUS SINGLE/BURST
    wire    [25:0]  P1InstADR       ; // INSTRUCTION BUS ADDRESS
    wire    [31:0]  P1InstRD        ; // INSTRUCTION BUS READ DATA
    wire            P1InstRDAK      ; // INSTRUCTION BUS READ DATA ACK

    wire            P1DataCRQ       ; // DATA BUS COMMAND REQ
    wire            P1DataCAK       ; // DATA BUS COMMAND ACK
    wire            P1DataBRST      ; // DATA BUS SINGLE/BURST
    wire            P1DataRW        ; // DATA BUS READ/WRITE (1:WRITE)
    wire    [3:0]   P1DataBE        ; // DATA BUS BYTE ENABLE
    wire    [27:0]  P1DataADR       ; // DATA BUS ADDRESS
    wire    [31:0]  P1DataWD        ; // DATA BUS WRITE DATA
    wire            P1DataWDAK      ; // DATA BUS WRITE DATA ACK
    wire    [31:0]  P1DataRD        ; // DATA BUS READ DATA
    wire            P1DataRDAK      ; // DATA BUS READ DATA ACK

    wire            P1DbgRq         ; // Debug Reqest from Debugger
    wire            P1DbgEna        ; // Debug Enable to Debugger
    wire            P1Break         ; // BREAK Instruction Detect Signal to Debugger
    wire            P1DecInstAK     ; // Ack of Instruction Reqest to DECU
    wire            P1Bubble        ; // Bubble
    wire            P1DbgRWe        ; // Register Write Enable from Debugger
    wire    [31:0]  P1DbgRD         ; // Register Read  Data to   Debugger

    wire            P1CoreGoAhead   ;
    wire            P1CoreInstRQ    ;
    wire            P1CoreInstAK    ;
    wire            P1CoreInstHit   ;
    wire            P1CoreDataRQ    ;
    wire            P1CoreDataAK    ;
    wire            P1CoreDataHit   ;

    //======== DEBUG===================================================
    wire            CacheClr        ;
    wire            P3dRstN         ;

    wire    [4:0]   DbgRAdr         ; // Register Address from Debugger
    wire    [31:0]  DbgWD           ; // Register Write Data from Debugger

    wire            DbgBusCRQ       ;
    wire            DbgBusCAK       ;
    wire    [27:0]  DbgBusADR       ;
    wire            DbgBusRW        ;
    wire    [3:0]   DbgBusBE        ;
    wire    [31:0]  DbgBusWD        ;
    wire            DbgBusWDAK      ;
    wire    [31:0]  DbgBusRD        ;
    wire            DbgBusRDAK      ;

    //======= P0 BusSplit1 ================
    wire            P0InstFlashCRQ  ;
    wire            P0InstFlashCAK  ;
    wire            P0InstFlashBRST ;
    wire    [25:0]  P0InstFlashADR  ;
    wire    [31:0]  P0InstFlashRD   ;
    wire            P0InstFlashRDAK ;

    wire            P0InstDdrCRQ    ;
    wire            P0InstDdrCAK    ;
    wire            P0InstDdrBRST   ;
    wire    [25:0]  P0InstDdrADR    ;
    wire    [31:0]  P0InstDdrRD     ;
    wire            P0InstDdrRDAK   ;

    //======= P1 BusSplit1 ================
    wire            P1InstFlashCRQ  ;
    wire            P1InstFlashCAK  ;
    wire            P1InstFlashBRST ;
    wire    [25:0]  P1InstFlashADR  ;
    wire    [31:0]  P1InstFlashRD   ;
    wire            P1InstFlashRDAK ;

    wire            P1InstDdrCRQ    ;
    wire            P1InstDdrCAK    ;
    wire            P1InstDdrBRST   ;
    wire    [25:0]  P1InstDdrADR    ;
    wire    [31:0]  P1InstDdrRD     ;
    wire            P1InstDdrRDAK   ;

    //======= P0 BusSplit2 ================
    wire            P0DataFlashCRQ  ;
    wire            P0DataFlashCAK  ;
    wire            P0DataFlashBRST ;
    wire            P0DataFlashRW   ;
    wire    [3:0]   P0DataFlashBE   ;
    wire    [25:0]  P0DataFlashADR  ;
    wire    [31:0]  P0DataFlashWD   ;
    wire            P0DataFlashWDAK ;
    wire    [31:0]  P0DataFlashRD   ;
    wire            P0DataFlashRDAK ;

    wire            P0DataDdrCRQ    ;
    wire            P0DataDdrCAK    ;
    wire            P0DataDdrBRST   ;
    wire            P0DataDdrRW     ;
    wire    [3:0]   P0DataDdrBE     ;
    wire    [25:0]  P0DataDdrADR    ;
    wire    [31:0]  P0DataDdrWD     ;
    wire            P0DataDdrWDAK   ;
    wire    [31:0]  P0DataDdrRD     ;
    wire            P0DataDdrRDAK   ;

    wire            P0DataPeriRQ    ;
    wire            P0DataPeriAK    ;
    wire            P0DataPeriRW    ;
    wire    [3:0]   P0DataPeriBE    ;
    wire    [15:0]  P0DataPeriADR   ;
    wire    [31:0]  P0DataPeriWD    ;
    wire    [31:0]  P0DataPeriRD    ;

    //======= P1 BusSplit2 ================
    wire            P1DataFlashCRQ  ;
    wire            P1DataFlashCAK  ;
    wire            P1DataFlashBRST ;
    wire            P1DataFlashRW   ;
    wire    [3:0]   P1DataFlashBE   ;
    wire    [25:0]  P1DataFlashADR  ;
    wire    [31:0]  P1DataFlashWD   ;
    wire            P1DataFlashWDAK ;
    wire    [31:0]  P1DataFlashRD   ;
    wire            P1DataFlashRDAK ;

    wire            P1DataDdrCRQ    ;
    wire            P1DataDdrCAK    ;
    wire            P1DataDdrBRST   ;
    wire            P1DataDdrRW     ;
    wire    [3:0]   P1DataDdrBE     ;
    wire    [25:0]  P1DataDdrADR    ;
    wire    [31:0]  P1DataDdrWD     ;
    wire            P1DataDdrWDAK   ;
    wire    [31:0]  P1DataDdrRD     ;
    wire            P1DataDdrRDAK   ;

    wire            P1DataPeriRQ    ;
    wire            P1DataPeriAK    ;
    wire            P1DataPeriRW    ;
    wire    [3:0]   P1DataPeriBE    ;
    wire    [15:0]  P1DataPeriADR   ;
    wire    [31:0]  P1DataPeriWD    ;
    wire    [31:0]  P1DataPeriRD    ;

    //======= BusSplit3 ================
    wire            OcdFlashCRQ     ;
    wire            OcdFlashCAK     ;
    wire            OcdFlashBRST    ;
    wire            OcdFlashRW      ;
    wire    [3:0]   OcdFlashBE      ;
    wire    [25:0]  OcdFlashADR     ;
    wire    [31:0]  OcdFlashWD      ;
    wire            OcdFlashWDAK    ;
    wire    [31:0]  OcdFlashRD      ;
    wire            OcdFlashRDAK    ;

    wire            OcdDdrCRQ       ;
    wire            OcdDdrCAK       ;
    wire            OcdDdrBRST      ;
    wire            OcdDdrRW        ;
    wire    [3:0]   OcdDdrBE        ;
    wire    [25:0]  OcdDdrADR       ;
    wire    [31:0]  OcdDdrWD        ;
    wire            OcdDdrWDAK      ;
    wire    [31:0]  OcdDdrRD        ;
    wire            OcdDdrRDAK      ;

    wire            OcdPeriRQ       ;
    wire            OcdPeriAK       ;
    wire            OcdPeriRW       ;
    wire    [3:0]   OcdPeriBE       ;
    wire    [15:0]  OcdPeriADR      ;
    wire    [31:0]  OcdPeriWD       ;
    wire    [31:0]  OcdPeriRD       ;

    //======= VGA ========================
    wire            VgaCRQ          ;
    wire            VgaCAK          ;
    wire    [25:0]  VgaADR          ;
    wire    [31:0]  VgaRD           ;
    wire            VgaRDAK         ;

    //======= Lcd ========================
    wire    [7:4]   LcdDB           ;
    wire    [11:0]  GpInOutMode     ;
    wire    [11:0]  GpInPut         ;
    wire    [11:0]  GpOutPut        ;

    //===========================================================================
    //======== BODY  ============================================================
    //===========================================================================
    assign  RESET = PushSW[2]; // SOUTH BTN

    //================== GPIO ============================
    assign FX2_IO1   = (GpInOutMode[ 0])? GpOutPut[ 0] : 1'bz ;
    assign FX2_IO2   = (GpInOutMode[ 1])? GpOutPut[ 1] : 1'bz ;
    assign FX2_IO3   = (GpInOutMode[ 2])? GpOutPut[ 2] : 1'bz ;
    assign FX2_IO4   = (GpInOutMode[ 3])? GpOutPut[ 3] : 1'bz ;
    assign FX2_IO5   = (GpInOutMode[ 4])? GpOutPut[ 4] : 1'bz ;
    assign FX2_IO6   = (GpInOutMode[ 5])? GpOutPut[ 5] : 1'bz ;
    assign FX2_IO7   = (GpInOutMode[ 6])? GpOutPut[ 6] : 1'bz ;
    assign FX2_IO8   = (GpInOutMode[ 7])? GpOutPut[ 7] : 1'bz ;
    assign FX2_IO9   = (GpInOutMode[ 8])? GpOutPut[ 8] : 1'bz ;
    assign FX2_IO10  = (GpInOutMode[ 9])? GpOutPut[ 9] : 1'bz ;
    assign FX2_IO11  = (GpInOutMode[10])? GpOutPut[10] : 1'bz ;
    assign FX2_IO12  = (GpInOutMode[11])? GpOutPut[11] : 1'bz ;

    assign GpInPut[ 0] = FX2_IO1 ;
    assign GpInPut[ 1] = FX2_IO2 ;
    assign GpInPut[ 2] = FX2_IO3 ;
    assign GpInPut[ 3] = FX2_IO4 ;
    assign GpInPut[ 4] = FX2_IO5 ;
    assign GpInPut[ 5] = FX2_IO6 ;
    assign GpInPut[ 6] = FX2_IO7 ;
    assign GpInPut[ 7] = FX2_IO8 ;
    assign GpInPut[ 8] = FX2_IO9 ;
    assign GpInPut[ 9] = FX2_IO10;
    assign GpInPut[10] = FX2_IO11;
    assign GpInPut[11] = FX2_IO12;

    //=========== (OUTPUT)RESERVE ============================
    assign  AD_CONV     = 1'b0; // H-Active
    assign  AMP_CS      = 1'b1; // L-Active
    assign  AMP_SHDN    = 1'b0; // H-Active RESET
    assign  DAC_CLR     = 1'b1; // L-Active RESET
    assign  DAC_CS      = 1'b1; // L-Active
    assign  E_MDC       = 1'b0; // clock
    assign  E_TX_EN     = 1'b0; // H-Active
    assign  E_TXD       = 4'b0000;
    assign  SPI_MOSI    = 1'b0;
    assign  SPI_SCK     = 1'b0;
    //assign    SPI_SS_B    = 1'b1; // L-Active
    assign   XC_CMD     = 2'b00;
    assign   XC_CPLD_EN = 1'b0;
    assign   XC_D       = 3'b000;
    assign   XC_GCK0    = 1'b0;

    //============================================================
    //======== Serial Port Selecter ==============================
    //============================================================
    assign  TxD0    = (SlideSW[1])? UartTxD  : OcdTxD;
    assign  TxD1    = (SlideSW[1])? OcdTxD   : UartTxD;
    assign  OcdRxD  = (SlideSW[1])? RxD1     : RxD0;
    assign  UartRxD = (SlideSW[1])? RxD0     : RxD1;

    //============================================================
    //======== CLOCK =============================================
    //============================================================
    ClkRstGen ClkRstGen(
        .CK50M           ( CK50M         ),
        .CLK_AUX         ( CLK_AUX       ),
        .CLK_SMA         ( CLK_SMA       ),
        .RESET           ( RESET         ),
        .FX2_CLKIO       ( FX2_CLKIO     ),

        .Clk             ( Clk           ),
        .Clk100m         ( Clk100m       ),
        .Clk100mP270     ( Clk100mP270   ),
        .RstN            ( RstN          ),
        .DdrRstN         ( DdrRstN       ),

        .Clk16x230k4     ( Clk16x230k4   ),
        .Clk16x115k2     ( Clk16x115k2   ),
        .Clk16x56k       ( Clk16x56k     ),
        .Clk16x38k4      ( Clk16x38k4    ),
        .Clk16x19k2      ( Clk16x19k2    ),
        .Clk16x9k6       ( Clk16x9k6     )
    );

    //============================================================
    //======== PSM3 DUAL CORE ====================================
    //============================================================
    P3dTop P3dTop(
        .Clk             ( Clk             ),
        .RstN            ( P3dRstN         ),

        .CacheClr        ( CacheClr        ),

        .P0IRQ           ( IrqOut0         ),

        .P0InstCRQ       ( P0InstCRQ       ),
        .P0InstCAK       ( P0InstCAK       ),
        .P0InstBRST      ( P0InstBRST      ),
        .P0InstADR       ( P0InstADR       ),
        .P0InstRD        ( P0InstRD        ),
        .P0InstRDAK      ( P0InstRDAK      ),

        .P0DataCRQ       ( P0DataCRQ       ),
        .P0DataCAK       ( P0DataCAK       ),
        .P0DataBRST      ( P0DataBRST      ),
        .P0DataRW        ( P0DataRW        ),
        .P0DataBE        ( P0DataBE        ),
        .P0DataADR       ( P0DataADR       ),
        .P0DataWD        ( P0DataWD        ),
        .P0DataWDAK      ( P0DataWDAK      ),
        .P0DataRD        ( P0DataRD        ),
        .P0DataRDAK      ( P0DataRDAK      ),

        .P0Break         ( P0Break         ),
        .P0DbgRq         ( P0DbgRq         ),
        .P0DbgRegRq      ( P0DbgRegRq      ),
        .P0DbgEna        ( P0DbgEna        ),
        .P0DbgRegWe      ( P0DbgRWe        ),
        .P0DbgRegAdr     ( DbgRAdr         ),
        .P0DbgWD         ( DbgWD           ),
        .P0DbgRD         ( P0DbgRD         ),
        .P0DecInstAK     ( P0DecInstAK     ),
        .P0Bubble        ( P0Bubble        ),

        .P0CoreGoAhead   ( P0CoreGoAhead   ),
        .P0CoreInstRQ    ( P0CoreInstRQ    ),
        .P0CoreInstAK    ( P0CoreInstAK    ),
        .P0CoreInstHit   ( P0CoreInstHit   ),
        .P0CoreDataRQ    ( P0CoreDataRQ    ),
        .P0CoreDataAK    ( P0CoreDataAK    ),
        .P0CoreDataHit   ( P0CoreDataHit   ),


        .P1IRQ           ( IrqOut1         ),

        .P1InstCRQ       ( P1InstCRQ       ),
        .P1InstCAK       ( P1InstCAK       ),
        .P1InstBRST      ( P1InstBRST      ),
        .P1InstADR       ( P1InstADR       ),
        .P1InstRD        ( P1InstRD        ),
        .P1InstRDAK      ( P1InstRDAK      ),

        .P1DataCRQ       ( P1DataCRQ       ),
        .P1DataCAK       ( P1DataCAK       ),
        .P1DataBRST      ( P1DataBRST      ),
        .P1DataRW        ( P1DataRW        ),
        .P1DataBE        ( P1DataBE        ),
        .P1DataADR       ( P1DataADR       ),
        .P1DataWD        ( P1DataWD        ),
        .P1DataWDAK      ( P1DataWDAK      ),
        .P1DataRD        ( P1DataRD        ),
        .P1DataRDAK      ( P1DataRDAK      ),

        .P1Break         ( P1Break         ),
        .P1DbgRq         ( P1DbgRq         ),
        .P1DbgRegRq      ( P1DbgRegRq      ),
        .P1DbgEna        ( P1DbgEna        ),
        .P1DbgRegWe      ( P1DbgRWe        ),
        .P1DbgRegAdr     ( DbgRAdr         ),
        .P1DbgWD         ( DbgWD           ),
        .P1DbgRD         ( P1DbgRD         ),
        .P1DecInstAK     ( P1DecInstAK     ),
        .P1Bubble        ( P1Bubble        ),

        .P1CoreGoAhead   ( P1CoreGoAhead   ),
        .P1CoreInstRQ    ( P1CoreInstRQ    ),
        .P1CoreInstAK    ( P1CoreInstAK    ),
        .P1CoreInstHit   ( P1CoreInstHit   ),
        .P1CoreDataRQ    ( P1CoreDataRQ    ),
        .P1CoreDataAK    ( P1CoreDataAK    ),
        .P1CoreDataHit   ( P1CoreDataHit   )
    );

    //============================================================
    //======== P3Ocd =============================================
    //============================================================
    P3dOcd P3dOcd(
        .Clk             ( Clk             ),
        .RstN            ( RstN            ),
        //.UartCKx16       ( Clk16x115k2     ), // UART:115.2Kbps
        .UartCKx16       ( Clk16x230k4     ), // UART:230.4Kbps

        .CacheClr        ( CacheClr        ),
        .P3dRstN         ( P3dRstN         ),

        .P0DbgRq         ( P0DbgRq         ),
        .P0DbgRegRq      ( P0DbgRegRq      ),
        .P0DbgEna        ( P0DbgEna        ),
        .P0Break         ( P0Break         ),
        .P0DecInstAK     ( P0DecInstAK     ),
        .P0DbgRWe        ( P0DbgRWe        ),
        .P0DbgRD         ( P0DbgRD         ),
        .P0Bubble        ( P0Bubble        ),

        .DbgRAdr         ( DbgRAdr         ),
        .DbgWD           ( DbgWD           ),

        .P1DbgRq         ( P1DbgRq         ),
        .P1DbgRegRq      ( P1DbgRegRq      ),
        .P1DbgEna        ( P1DbgEna        ),
        .P1Break         ( P1Break         ),
        .P1DecInstAK     ( P1DecInstAK     ),
        .P1DbgRWe        ( P1DbgRWe        ),
        .P1DbgRD         ( P1DbgRD         ),
        .P1Bubble        ( P1Bubble        ),

        .DbgBusCRQ       ( DbgBusCRQ       ),
        .DbgBusCAK       ( DbgBusCAK       ),
        .DbgBusADR       ( DbgBusADR       ),
        .DbgBusRW        ( DbgBusRW        ),
        .DbgBusBE        ( DbgBusBE        ),
        .DbgBusWD        ( DbgBusWD        ),
        .DbgBusWDAK      ( DbgBusWDAK      ),
        .DbgBusRD        ( DbgBusRD        ),
        .DbgBusRDAK      ( DbgBusRDAK      ),

        .TxD             ( OcdTxD          ),
        .RxD             ( OcdRxD          )
    );

    //============================================================
    //======== Inst Bus Spliter For PSM3 P0 ======================
    //============================================================
    BusSplit1 P0BusSplit1(
        .MemMapMode      ( SlideSW[0]      ),

        .MstrCRQ         ( P0InstCRQ       ),
        .MstrCAK         ( P0InstCAK       ),
        .MstrBRST        ( P0InstBRST      ),
        .MstrADR         ( P0InstADR       ),
        .MstrRD          ( P0InstRD        ),
        .MstrRDAK        ( P0InstRDAK      ),

        .FlashCRQ        ( P0InstFlashCRQ  ),
        .FlashCAK        ( P0InstFlashCAK  ),
        .FlashBRST       ( P0InstFlashBRST ),
        .FlashADR        ( P0InstFlashADR  ),
        .FlashRD         ( P0InstFlashRD   ),
        .FlashRDAK       ( P0InstFlashRDAK ),

        .DdrCRQ          ( P0InstDdrCRQ    ),
        .DdrCAK          ( P0InstDdrCAK    ),
        .DdrBRST         ( P0InstDdrBRST   ),
        .DdrADR          ( P0InstDdrADR    ),
        .DdrRD           ( P0InstDdrRD     ),
        .DdrRDAK         ( P0InstDdrRDAK   )
    );

    //============================================================
    //======== Inst Bus Spliter For PSM3 P1 ======================
    //============================================================
    BusSplit1 P1BusSplit1(
        .MemMapMode      ( SlideSW[0]      ),

        .MstrCRQ         ( P1InstCRQ       ),
        .MstrCAK         ( P1InstCAK       ),
        .MstrBRST        ( P1InstBRST      ),
        .MstrADR         ( P1InstADR       ),
        .MstrRD          ( P1InstRD        ),
        .MstrRDAK        ( P1InstRDAK      ),

        .FlashCRQ        ( P1InstFlashCRQ  ),
        .FlashCAK        ( P1InstFlashCAK  ),
        .FlashBRST       ( P1InstFlashBRST ),
        .FlashADR        ( P1InstFlashADR  ),
        .FlashRD         ( P1InstFlashRD   ),
        .FlashRDAK       ( P1InstFlashRDAK ),

        .DdrCRQ          ( P1InstDdrCRQ    ),
        .DdrCAK          ( P1InstDdrCAK    ),
        .DdrBRST         ( P1InstDdrBRST   ),
        .DdrADR          ( P1InstDdrADR    ),
        .DdrRD           ( P1InstDdrRD     ),
        .DdrRDAK         ( P1InstDdrRDAK   )

    );

    //============================================================
    //======== Data Bus Spliter For PSM3 P0 ======================
    //============================================================
    BusSplit2 P0BusSplit2(
        .MemMapMode      ( SlideSW[0]      ),

        .MstrCRQ         ( P0DataCRQ       ),
        .MstrCAK         ( P0DataCAK       ),
        .MstrBRST        ( P0DataBRST      ),
        .MstrRW          ( P0DataRW        ),
        .MstrBE          ( P0DataBE        ),
        .MstrADR         ( P0DataADR       ),
        .MstrWD          ( P0DataWD        ),
        .MstrWDAK        ( P0DataWDAK      ),
        .MstrRD          ( P0DataRD        ),
        .MstrRDAK        ( P0DataRDAK      ),

        .FlashCRQ        ( P0DataFlashCRQ  ),
        .FlashCAK        ( P0DataFlashCAK  ),
        .FlashBRST       ( P0DataFlashBRST ),
        .FlashRW         ( P0DataFlashRW   ),
        .FlashBE         ( P0DataFlashBE   ),
        .FlashADR        ( P0DataFlashADR  ),
        .FlashWD         ( P0DataFlashWD   ),
        .FlashWDAK       ( P0DataFlashWDAK ),
        .FlashRD         ( P0DataFlashRD   ),
        .FlashRDAK       ( P0DataFlashRDAK ),

        .DdrCRQ          ( P0DataDdrCRQ    ),
        .DdrCAK          ( P0DataDdrCAK    ),
        .DdrBRST         ( P0DataDdrBRST   ),
        .DdrRW           ( P0DataDdrRW     ),
        .DdrBE           ( P0DataDdrBE     ),
        .DdrADR          ( P0DataDdrADR    ),
        .DdrWD           ( P0DataDdrWD     ),
        .DdrWDAK         ( P0DataDdrWDAK   ),
        .DdrRD           ( P0DataDdrRD     ),
        .DdrRDAK         ( P0DataDdrRDAK   ),

        .PeriRQ          ( P0DataPeriRQ    ),
        .PeriAK          ( P0DataPeriAK    ),
        .PeriRW          ( P0DataPeriRW    ),
        .PeriBE          ( P0DataPeriBE    ),
        .PeriADR         ( P0DataPeriADR   ),
        .PeriWD          ( P0DataPeriWD    ),
        .PeriRD          ( P0DataPeriRD    )
    );

    //============================================================
    //======== Data Bus Spliter For PSM3 P1 ======================
    //============================================================
    BusSplit2 P1BusSplit2(
        .MemMapMode      ( SlideSW[0]      ),

        .MstrCRQ         ( P1DataCRQ       ),
        .MstrCAK         ( P1DataCAK       ),
        .MstrBRST        ( P1DataBRST      ),
        .MstrRW          ( P1DataRW        ),
        .MstrBE          ( P1DataBE        ),
        .MstrADR         ( P1DataADR       ),
        .MstrWD          ( P1DataWD        ),
        .MstrWDAK        ( P1DataWDAK      ),
        .MstrRD          ( P1DataRD        ),
        .MstrRDAK        ( P1DataRDAK      ),

        .FlashCRQ        ( P1DataFlashCRQ  ),
        .FlashCAK        ( P1DataFlashCAK  ),
        .FlashBRST       ( P1DataFlashBRST ),
        .FlashRW         ( P1DataFlashRW   ),
        .FlashBE         ( P1DataFlashBE   ),
        .FlashADR        ( P1DataFlashADR  ),
        .FlashWD         ( P1DataFlashWD   ),
        .FlashWDAK       ( P1DataFlashWDAK ),
        .FlashRD         ( P1DataFlashRD   ),
        .FlashRDAK       ( P1DataFlashRDAK ),

        .DdrCRQ          ( P1DataDdrCRQ    ),
        .DdrCAK          ( P1DataDdrCAK    ),
        .DdrBRST         ( P1DataDdrBRST   ),
        .DdrRW           ( P1DataDdrRW     ),
        .DdrBE           ( P1DataDdrBE     ),
        .DdrADR          ( P1DataDdrADR    ),
        .DdrWD           ( P1DataDdrWD     ),
        .DdrWDAK         ( P1DataDdrWDAK   ),
        .DdrRD           ( P1DataDdrRD     ),
        .DdrRDAK         ( P1DataDdrRDAK   ),

        .PeriRQ          ( P1DataPeriRQ    ),
        .PeriAK          ( P1DataPeriAK    ),
        .PeriRW          ( P1DataPeriRW    ),
        .PeriBE          ( P1DataPeriBE    ),
        .PeriADR         ( P1DataPeriADR   ),
        .PeriWD          ( P1DataPeriWD    ),
        .PeriRD          ( P1DataPeriRD    )
    );

    //============================================================
    //======== Data Bus Spliter For OCD ======================
    //============================================================
    BusSplit2 DbgBusSplit2(
        .MemMapMode      ( SlideSW[0]      ),

        .MstrCRQ         ( DbgBusCRQ       ),
        .MstrCAK         ( DbgBusCAK       ),
        .MstrBRST        ( 1'b0            ),
        .MstrRW          ( DbgBusRW        ),
        .MstrBE          ( DbgBusBE        ),
        .MstrADR         ( DbgBusADR       ),
        .MstrWD          ( DbgBusWD        ),
        .MstrWDAK        ( DbgBusWDAK      ),
        .MstrRD          ( DbgBusRD        ),
        .MstrRDAK        ( DbgBusRDAK      ),

        .FlashCRQ        ( OcdFlashCRQ     ),
        .FlashCAK        ( OcdFlashCAK     ),
        .FlashBRST       ( OcdFlashBRST    ),
        .FlashRW         ( OcdFlashRW      ),
        .FlashBE         ( OcdFlashBE      ),
        .FlashADR        ( OcdFlashADR     ),
        .FlashWD         ( OcdFlashWD      ),
        .FlashWDAK       ( OcdFlashWDAK    ),
        .FlashRD         ( OcdFlashRD      ),
        .FlashRDAK       ( OcdFlashRDAK    ),

        .DdrCRQ          ( OcdDdrCRQ       ),
        .DdrCAK          ( OcdDdrCAK       ),
        .DdrBRST         ( OcdDdrBRST      ),
        .DdrRW           ( OcdDdrRW        ),
        .DdrBE           ( OcdDdrBE        ),
        .DdrADR          ( OcdDdrADR       ),
        .DdrWD           ( OcdDdrWD        ),
        .DdrWDAK         ( OcdDdrWDAK      ),
        .DdrRD           ( OcdDdrRD        ),
        .DdrRDAK         ( OcdDdrRDAK      ),

        .PeriRQ          ( OcdPeriRQ       ),
        .PeriAK          ( OcdPeriAK       ),
        .PeriRW          ( OcdPeriRW       ),
        .PeriBE          ( OcdPeriBE       ),
        .PeriADR         ( OcdPeriADR      ),
        .PeriWD          ( OcdPeriWD       ),
        .PeriRD          ( OcdPeriRD       )
    );

    //============================================================
    //======== DDR-SDRAM I/F        ==============================
    //============================================================
    DdrIfTop DdrIfTop(
        .Clk             ( Clk               ),
        .DdrClk          ( Clk100m           ),
        .DdrClkP270      ( Clk100mP270       ),
        .RstN            ( RstN              ),
        .DdrRstN         ( DdrRstN           ),

        //============ VGA   ================
        .Mstr0CRQ        ( VgaCRQ            ),
        .Mstr0CAK        ( VgaCAK            ),
        .Mstr0BRST       ( 1'b1              ),
        .Mstr0RW         ( 1'b0              ),
        .Mstr0BE         ( 4'b1111           ),
        .Mstr0ADR        ( VgaADR[25:2]      ),
        .Mstr0WD         ( 32'h0             ),
        .Mstr0WDAK       (                   ),
        .Mstr0RD         ( VgaRD             ),
        .Mstr0RDAK       ( VgaRDAK           ),


        //============ P0 DATA ================
        .Mstr1CRQ        ( P0DataDdrCRQ      ),
        .Mstr1CAK        ( P0DataDdrCAK      ),
        .Mstr1BRST       ( P0DataDdrBRST     ),
        .Mstr1RW         ( P0DataDdrRW       ),
        .Mstr1BE         ( P0DataDdrBE       ),
        .Mstr1ADR        ( P0DataDdrADR[25:2]),
        .Mstr1WD         ( P0DataDdrWD       ),
        .Mstr1WDAK       ( P0DataDdrWDAK     ),
        .Mstr1RD         ( P0DataDdrRD       ),
        .Mstr1RDAK       ( P0DataDdrRDAK     ),

        //============ P0 INST ================
        .Mstr2CRQ        ( P0InstDdrCRQ      ),
        .Mstr2CAK        ( P0InstDdrCAK      ),
        .Mstr2BRST       ( P0InstDdrBRST     ),
        .Mstr2RW         ( 1'b0              ),
        .Mstr2BE         ( 4'b1111           ),
        .Mstr2ADR        ( P0InstDdrADR[25:2]),
        .Mstr2WD         ( 32'h0             ),
        .Mstr2WDAK       (                   ),
        .Mstr2RD         ( P0InstDdrRD       ),
        .Mstr2RDAK       ( P0InstDdrRDAK     ),

        //============ P1 DATA  ================
        .Mstr3CRQ        ( P1DataDdrCRQ      ),
        .Mstr3CAK        ( P1DataDdrCAK      ),
        .Mstr3BRST       ( P1DataDdrBRST     ),
        .Mstr3RW         ( P1DataDdrRW       ),
        .Mstr3BE         ( P1DataDdrBE       ),
        .Mstr3ADR        ( P1DataDdrADR[25:2]),
        .Mstr3WD         ( P1DataDdrWD       ),
        .Mstr3WDAK       ( P1DataDdrWDAK     ),
        .Mstr3RD         ( P1DataDdrRD       ),
        .Mstr3RDAK       ( P1DataDdrRDAK     ),

        //============ P1 INST ================
        .Mstr4CRQ        ( P1InstDdrCRQ      ),
        .Mstr4CAK        ( P1InstDdrCAK      ),
        .Mstr4BRST       ( P1InstDdrBRST     ),
        .Mstr4RW         ( 1'b0              ),
        .Mstr4BE         ( 4'b1111           ),
        .Mstr4ADR        ( P1InstDdrADR[25:2]),
        .Mstr4WD         ( 32'h0             ),
        .Mstr4WDAK       (                   ),
        .Mstr4RD         ( P1InstDdrRD       ),
        .Mstr4RDAK       ( P1InstDdrRDAK     ),

        //============ OCD    ================
        .Mstr5CRQ        ( OcdDdrCRQ         ),
        .Mstr5CAK        ( OcdDdrCAK         ),
        .Mstr5BRST       ( OcdDdrBRST        ),
        .Mstr5RW         ( OcdDdrRW          ),
        .Mstr5BE         ( OcdDdrBE          ),
        .Mstr5ADR        ( OcdDdrADR[25:2]   ),
        .Mstr5WD         ( OcdDdrWD          ),
        .Mstr5WDAK       ( OcdDdrWDAK        ),
        .Mstr5RD         ( OcdDdrRD          ),
        .Mstr5RDAK       ( OcdDdrRDAK        ),

        .DDRCK           ( DDRCK             ),
        .DDRNCK          ( DDRNCK            ),
        .DDRCKE          ( DDRCKE            ),
        .DDRNCS          ( DDRNCS            ),
        .DDRRAS          ( DDRRAS            ),
        .DDRCAS          ( DDRCAS            ),
        .DDRNWE          ( DDRNWE            ),
        .DDRBA           ( DDRBA             ),
        .DDRA            ( DDRA              ),
        .DDRDQS          ( DDRDQS            ),
        .DDRDM           ( DDRDM             ),
        .DDRDQ           ( DDRDQ             )
    );

    //============================================================
    //======== FLASH I/F      =====================================
    //============================================================
    FlashIf FlashIf(
        .Clk             ( Clk                  ),
        .RstN            ( RstN                 ),

        .Mstr0CRQ        ( P0InstFlashCRQ       ),
        .Mstr0CAK        ( P0InstFlashCAK       ),
        .Mstr0BRST       ( P0InstFlashBRST      ),
        .Mstr0RW         ( 1'b0                 ),
        .Mstr0BE         ( 4'b1111              ),
        .Mstr0ADR        ( P0InstFlashADR[25:2] ),
        .Mstr0WD         ( 32'h0                ),
        .Mstr0WDAK       (                      ),
        .Mstr0RD         ( P0InstFlashRD        ),
        .Mstr0RDAK       ( P0InstFlashRDAK      ),

        .Mstr1CRQ        ( P0DataFlashCRQ       ),
        .Mstr1CAK        ( P0DataFlashCAK       ),
        .Mstr1BRST       ( P0DataFlashBRST      ),
        .Mstr1RW         ( P0DataFlashRW        ),
        .Mstr1BE         ( P0DataFlashBE        ),
        .Mstr1ADR        ( P0DataFlashADR[25:2] ),
        .Mstr1WD         ( P0DataFlashWD        ),
        .Mstr1WDAK       ( P0DataFlashWDAK      ),
        .Mstr1RD         ( P0DataFlashRD        ),
        .Mstr1RDAK       ( P0DataFlashRDAK      ),

        .Mstr2CRQ        ( P1InstFlashCRQ       ),
        .Mstr2CAK        ( P1InstFlashCAK       ),
        .Mstr2BRST       ( P1InstFlashBRST      ),
        .Mstr2RW         ( 1'b0                 ),
        .Mstr2BE         ( 4'b1111              ),
        .Mstr2ADR        ( P1InstFlashADR[25:2] ),
        .Mstr2WD         ( 32'h0                ),
        .Mstr2WDAK       (                      ),
        .Mstr2RD         ( P1InstFlashRD        ),
        .Mstr2RDAK       ( P1InstFlashRDAK      ),

        .Mstr3CRQ        ( P1DataFlashCRQ       ),
        .Mstr3CAK        ( P1DataFlashCAK       ),
        .Mstr3BRST       ( P1DataFlashBRST      ),
        .Mstr3RW         ( P1DataFlashRW        ),
        .Mstr3BE         ( P1DataFlashBE        ),
        .Mstr3ADR        ( P1DataFlashADR[25:2] ),
        .Mstr3WD         ( P1DataFlashWD        ),
        .Mstr3WDAK       ( P1DataFlashWDAK      ),
        .Mstr3RD         ( P1DataFlashRD        ),
        .Mstr3RDAK       ( P1DataFlashRDAK      ),

        .Mstr4CRQ        ( OcdFlashCRQ          ),
        .Mstr4CAK        ( OcdFlashCAK          ),
        .Mstr4BRST       ( OcdFlashBRST         ),
        .Mstr4RW         ( OcdFlashRW           ),
        .Mstr4BE         ( OcdFlashBE           ),
        .Mstr4ADR        ( OcdFlashADR[25:2]    ),
        .Mstr4WD         ( OcdFlashWD           ),
        .Mstr4WDAK       ( OcdFlashWDAK         ),
        .Mstr4RD         ( OcdFlashRD           ),
        .Mstr4RDAK       ( OcdFlashRDAK         ),

        .SF_CE0          ( SF_CE0               ),
        .SF_OE           ( SF_OE                ),
        .SF_WE           ( SF_WE                ),
        .SF_BYTE         ( SF_BYTE              ),
        .SF_A            ( SF_A                 ),
        .SF_D            ( SF_D                 ),
        .SF_STS          ( SF_STS               )
    );

    //============================================================
    //======== PERIPHERAL        =================================
    //============================================================
    P3dPeriTop PeriTop(
        .Clk             ( Clk             ),
        .VgaClk          ( Clk100m         ),
        .RstN            ( RstN            ),

        .Clk16x115k2     ( Clk16x115k2     ),
        .Clk16x56k       ( Clk16x56k       ),
        .Clk16x38k4      ( Clk16x38k4      ),
        .Clk16x19k2      ( Clk16x19k2      ),
        .Clk16x9k6       ( Clk16x9k6       ),

        .PeriMstr0RQ     ( P0DataPeriRQ    ),
        .PeriMstr0AK     ( P0DataPeriAK    ),
        .PeriMstr0RW     ( P0DataPeriRW    ),
        .PeriMstr0BE     ( P0DataPeriBE    ),
        .PeriMstr0ADR    ( P0DataPeriADR   ),
        .PeriMstr0WD     ( P0DataPeriWD    ),
        .PeriMstr0RD     ( P0DataPeriRD    ),

        .PeriMstr1RQ     ( P1DataPeriRQ    ),
        .PeriMstr1AK     ( P1DataPeriAK    ),
        .PeriMstr1RW     ( P1DataPeriRW    ),
        .PeriMstr1BE     ( P1DataPeriBE    ),
        .PeriMstr1ADR    ( P1DataPeriADR   ),
        .PeriMstr1WD     ( P1DataPeriWD    ),
        .PeriMstr1RD     ( P1DataPeriRD    ),

        .PeriMstr2RQ     ( OcdPeriRQ       ),
        .PeriMstr2AK     ( OcdPeriAK       ),
        .PeriMstr2RW     ( OcdPeriRW       ),
        .PeriMstr2BE     ( OcdPeriBE       ),
        .PeriMstr2ADR    ( OcdPeriADR      ),
        .PeriMstr2WD     ( OcdPeriWD       ),
        .PeriMstr2RD     ( OcdPeriRD       ),

        .VgaCRQ          ( VgaCRQ          ),
        .VgaCAK          ( VgaCAK          ),
        .VgaADR          ( VgaADR          ),
        .VgaRD           ( VgaRD           ),
        .VgaRDAK         ( VgaRDAK         ),

        .VS              ( VS              ),
        .HS              ( HS              ),
        .VR              ( VR              ),
        .VG              ( VG              ),
        .VB              ( VB              ),

        .IrqOut0         ( IrqOut0         ),
        .IrqOut1         ( IrqOut1         ),

        .SlideSW         ( SlideSW         ),
        .PushSW          ( PushSW          ),
        .RotCenter       ( RotCenter       ),
        .RotA            ( RotA            ),
        .RotB            ( RotB            ),

        .LcdRW           ( LcdRW           ),
        .LcdE            ( LcdE            ),
        .LcdRS           ( LcdRS           ),
        .LcdDB           ( LcdDB           ),
        .LED             ( LED             ),
        .GpInOutMode     ( GpInOutMode     ),
        .GpInPut         ( GpInPut         ),
        .GpOutPut        ( GpOutPut        ),

        .RxD             ( UartRxD         ),
        .TxD             ( UartTxD         ),

        .P0CoreDbgRq     ( P0DbgRq         ),
        .P0CoreGoAhead   ( P0CoreGoAhead   ),
        .P0Bubble        ( P0Bubble        ),
        .P0CoreInstRQ    ( P0CoreInstRQ    ),
        .P0CoreInstAK    ( P0CoreInstAK    ),
        .P0CoreInstHit   ( P0CoreInstHit   ),
        .P0CoreDataRQ    ( P0CoreDataRQ    ),
        .P0CoreDataAK    ( P0CoreDataAK    ),
        .P0CoreDataHit   ( P0CoreDataHit   ),

        .P1CoreDbgRq     ( P1DbgRq         ),
        .P1CoreGoAhead   ( P1CoreGoAhead   ),
        .P1Bubble        ( P1Bubble        ),
        .P1CoreInstRQ    ( P1CoreInstRQ    ),
        .P1CoreInstAK    ( P1CoreInstAK    ),
        .P1CoreInstHit   ( P1CoreInstHit   ),
        .P1CoreDataRQ    ( P1CoreDataRQ    ),
        .P1CoreDataAK    ( P1CoreDataAK    ),
        .P1CoreDataHit   ( P1CoreDataHit   )
);

endmodule

