//============================================================
//  TARGET SYSTEM : *
//  FUNCTION      : ϒz񑀍pCu
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#include    "VLArray.h"

//====================================================================================================================
VLArray *VLArrayCreate(int (*Remove)(void *Object), int (*Find)(void *Object, void *Key))
//====================================================================================================================
// [@\] ϒzǗubN쐬
// [] ϒzɊi[Objectfree֐ւ̃|C^BwȂ̏ꍇNULLł悢
// [] ϒzɊi[ObjectKeygČ֐ւ̃|C^BwȂ̏ꍇNULLł悢
// [Ԓl] sNULLAAVLArrayւ̃|C^ԂB
{
    VLArray       *VLA;

    VLA = calloc(1, sizeof(VLArray));
    if(VLA == NULL) return NULL;
    VLA->NumOfMember = 0;
    VLA->ObjIndex = calloc(VL_ARRAY_UNIT_OF_INDEX, sizeof(void *));
    VLA->ObjIndexSize = VL_ARRAY_UNIT_OF_INDEX;
    VLA->Remove = Remove;
    VLA->Find   = Find;
    return  VLA;
}
//====================================================================================================================
int VLArrayRemove(VLArray *VLA)
//====================================================================================================================
// [@\] ϒz̊ǗubN݂̂폜
// [] VLArray *VLA     Fϒz
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    if(VLA == NULL) return VL_ARRAY_NG;
    free(VLA);
    return VL_ARRAY_OK;
}

//====================================================================================================================
int VLArrayRemoveAll(VLArray *VLA)
//====================================================================================================================
// [@\] ϒzŜ폜
// [] VLArray *VLA     F폜Ώۂ̉ϒz
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    int                 i;
    void                *Object;

    if(VLA == NULL) return VL_ARRAY_NG;

    for(i = 0; i < VLA->NumOfMember; i++){
        Object =  (VLA->ObjIndex)[i];
        if(VLA->Remove == NULL) free(Object);
        else                    (*(VLA->Remove))(Object);
    }
    free(VLA->ObjIndex);
    free(VLA);
    return VL_ARRAY_OK;
}

//====================================================================================================================
void  *VLArrayMemberAdd(VLArray *VLA,  void *Object, int ObjectSize)
//====================================================================================================================
// [@\] ϒz̍ŌɃoǉ(*Object̓Rs[ÃRs[ϒzɒǉ)
// [] VLArray *VLA     Fϒz
// [] void      *Object FǉIuWFNgւ̃|C^
// [] void      *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sNULLAAǉoւ̃|C^Ԃ
{
    int                 i;
    void                **Index;
    void                *NewObject;

    if(VLA == NULL) return NULL;
    if(Object == NULL) return NULL;
    if(ObjectSize <= 0) return NULL;

    NewObject = calloc(1, ObjectSize);
    if(NewObject == NULL) return NULL;
    memcpy(NewObject, Object, ObjectSize);

    VLA->NumOfMember += 1;
    if(VLA->NumOfMember >= VLA->ObjIndexSize){
        Index = realloc(VLA->ObjIndex, (sizeof(void *) * (VLA->ObjIndexSize + VL_ARRAY_UNIT_OF_INDEX)));
        if(Index == NULL) return NULL;
        for(i = VLA->NumOfMember ; i < (VLA->NumOfMember + VL_ARRAY_UNIT_OF_INDEX) ; i++) Index[i] = NULL;
        VLA->ObjIndex = Index;
        VLA->ObjIndexSize += VL_ARRAY_UNIT_OF_INDEX;
    }
    (VLA->ObjIndex)[VLA->NumOfMember - 1] = NewObject;
    return NewObject;
}

//====================================================================================================================
int VLArrayMemberRemove(VLArray *VLA,  int Position)
//====================================================================================================================
// [@\] ϒz񂩂PositonԖڂ̃o폜 (㑱̃o͑Ol)
// [] VLArray *VLA     Fϒz
// [] int       PositionF폜郁öʒu
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    int                 i;
    void                *Object;

    if(VLA == NULL) return VL_ARRAY_NG;
    if(Position >= VLA->NumOfMember) return VL_ARRAY_NG;

    Object = (VLA->ObjIndex)[Position];
    
    if(Object != NULL){
        if(VLA->Remove == NULL) free(Object);
        else                    (*(VLA->Remove))(Object);
    }

    VLA->NumOfMember -= 1;
    for(i = Position; i < VLA->NumOfMember; i++){
        (VLA->ObjIndex)[i] = (VLA->ObjIndex)[i + 1];
    }
    (VLA->ObjIndex)[i] = NULL;

    return VL_ARRAY_OK;
}

//====================================================================================================================
int VLArrayMemberInsertPrev(VLArray *VLA,  int Position, void *Object, int ObjectSize)
//====================================================================================================================
// [@\] ϒz񒆂Positon̑OɃoǉ(*Object̓Rs[A
//        ̃Rs[ϒzɑ})
//        Ⴆ΁APosition5ȂAVKǉꂽo5ԖڂɂȂāA
//        ܂5Ԗڂo6ԖڂɂȂB
//        ϒz񂪋Ȃ΁A擪ɒǉ
// [] VLArray        *VLA         F*Objectǉϒz
// [] int              Position    FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    int                 i;
    void                **Index;
    void                *NewObject;

    if(VLA == NULL) return VL_ARRAY_NG;
    if(Object == NULL) return VL_ARRAY_NG;
    if(ObjectSize <= 0) return VL_ARRAY_NG;
    if(Position >= VLA->NumOfMember) return VL_ARRAY_NG;
    if(VLA->NumOfMember == 0){
        if(VLArrayMemberAdd(VLA, Object, ObjectSize) != NULL) return VL_ARRAY_OK;
        else return VL_ARRAY_NG;
    }

    NewObject = calloc(1, ObjectSize);
    if(NewObject == NULL) return NULL;
    memcpy(NewObject, Object, ObjectSize);

    VLA->NumOfMember += 1;
    if(VLA->NumOfMember >= VLA->ObjIndexSize){
        Index = realloc(VLA->ObjIndex, (sizeof(void *) * (VLA->ObjIndexSize + VL_ARRAY_UNIT_OF_INDEX)));
        if(Index == NULL) return NULL;
        for(i = VLA->NumOfMember ; i < (VLA->NumOfMember + VL_ARRAY_UNIT_OF_INDEX) ; i++) Index[i] = NULL;
        VLA->ObjIndex = Index;
        VLA->ObjIndexSize += VL_ARRAY_UNIT_OF_INDEX;
    }

    for(i = VLA->NumOfMember - 1; i > Position; i--){
        (VLA->ObjIndex)[i] = (VLA->ObjIndex)[i - 1];
    }
    (VLA->ObjIndex)[Position] = NewObject;

    return VL_ARRAY_OK;
}
//====================================================================================================================
int VLArrayMemberInsertNext(VLArray *VLA,  int Position, void *Object, int ObjectSize)
//====================================================================================================================
// [@\] ϒz񒆂PositoňɃoǉ(*Object̓Rs[A
//        ̃Rs[VLArrayMember.ObjectɉϒzɂԂ牺)
//        Ⴆ΁APosition5ȂAVKǉꂽo6ԖڂɂȂāA
//        ܂5Ԗڂo5Ԗڂ̂܂܂ɂȂB
//        ϒz񂪋Ȃ΁A擪ɒǉ
// [] VLArray        *VLA         F*Objectǉϒz
// [] VLArrayMember  *Position   FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    int                 i;
    void                **Index;
    void                *NewObject;

    if(VLA == NULL) return VL_ARRAY_NG;
    if(Object == NULL) return VL_ARRAY_NG;
    if(ObjectSize <= 0) return VL_ARRAY_NG;
    if(Position >= VLA->NumOfMember) return VL_ARRAY_NG;
    if(VLA->NumOfMember == 0){
        if(VLArrayMemberAdd(VLA, Object, ObjectSize) != NULL) return VL_ARRAY_OK;
        else return VL_ARRAY_NG;
    }

    NewObject = calloc(1, ObjectSize);
    if(NewObject == NULL) return NULL;
    memcpy(NewObject, Object, ObjectSize);

    VLA->NumOfMember += 1;
    if(VLA->NumOfMember >= VLA->ObjIndexSize){
        Index = realloc(VLA->ObjIndex, (sizeof(void *) * (VLA->ObjIndexSize + VL_ARRAY_UNIT_OF_INDEX)));
        if(Index == NULL) return NULL;
        for(i = VLA->NumOfMember ; i < (VLA->NumOfMember + VL_ARRAY_UNIT_OF_INDEX) ; i++) Index[i] = NULL;
        VLA->ObjIndex = Index;
        VLA->ObjIndexSize += VL_ARRAY_UNIT_OF_INDEX;
    }

    for(i = VLA->NumOfMember - 1; i > Position + 1; i--){
        (VLA->ObjIndex)[i] = (VLA->ObjIndex)[i - 1];
    }
    (VLA->ObjIndex)[Position + 1] = NewObject;

    return VL_ARRAY_OK;
}

//====================================================================================================================
void *VLArrayMemberFind(VLArray *VLA, int Position, void *Key)
//====================================================================================================================
// [@\] VLAɓo^ꂽFind֐KeyL[ƂāAϒz񒆂Position猟A
//        ŏɌoւ̃|C^ԂB
//        ɎsAȂNULLԂ
// [] VLArray       *VLA       F*Objecti[ϒz
// [] int             Position  FJnʒu
// [] void            *Key      FL[ւ̃|C^
// [Ԓl] sNULL
{
    int                 i;
    void                *Object;

    if(VLA == NULL) return NULL;
    if(Position >= VLA->NumOfMember) return NULL;
    if(VLA->NumOfMember == 0) return NULL;
    if(VLA->Find == NULL) return NULL;

    for(i = Position; i < VLA->NumOfMember; i++){
        Object = (VLA->ObjIndex)[i];
        if((*(VLA->Find))(Object, Key) == VL_ARRAY_OK) return Object;
    }

    return NULL;
}

//====================================================================================================================
void *VLArrayMemberGet(VLArray *VLA,  int Position)
//====================================================================================================================
// [@\] ϒz̐擪PositonԖڂ̃oւ̃|C^Ԃ
// [] VLArray *VLA     Fϒz
// [] int       PositionFʒui擪 : Position == 0)
// [Ԓl] sNULL
{
    void                *Object;

    if(VLA == NULL) return NULL;
    if(Position < 0) return NULL;
    if(Position >= VLA->NumOfMember) return NULL;
    Object = (VLA->ObjIndex)[Position];

    return Object;
}

//====================================================================================================================
int VLArrayConnect(VLArray *LVA0,  VLArray *LVA1)
//====================================================================================================================
// [@\] LVA0LVA1A(LVA1̃wb_͏Ă̂܂܎ĉŃwb_񂻂̂̂KvΕʓr邱Ɓj
// [] VLArray *LVA0 Fϒz
// [] VLArray *LVA1 Fϒz
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    int                 i, j;
    void                **Index;

    if(LVA0 == NULL) return VL_ARRAY_NG;
    if(LVA1 == NULL) return VL_ARRAY_NG;

    if(LVA0->NumOfMember == 0){//̏ꍇ
        if(LVA1->NumOfMember != 0){//Kg
            free(LVA0->ObjIndex);
            *LVA0 = *LVA1;
            LVA1->NumOfMember = 0;
            LVA1->ObjIndex = calloc(VL_ARRAY_UNIT_OF_INDEX, sizeof(void *));
            LVA1->ObjIndexSize = VL_ARRAY_UNIT_OF_INDEX;
        }
        else{//KgȂ
            ;
        }
    }
    else if(LVA1->NumOfMember != 0){//gAKg
        Index = realloc(LVA0->ObjIndex, (sizeof(void *) * (LVA0->ObjIndexSize + LVA1->ObjIndexSize)));
        if(Index == NULL) return VL_ARRAY_NG;
        for(i = LVA0->NumOfMember, j = 0; j < LVA1->NumOfMember ; i++, j++) Index[i] = (LVA1->ObjIndex)[j];
        LVA0->ObjIndex = Index;
        LVA0->ObjIndexSize += LVA1->ObjIndexSize;
        LVA0->NumOfMember += LVA1->NumOfMember;
        free(LVA1->ObjIndex);
        LVA1->NumOfMember = 0;
        LVA1->ObjIndex = calloc(VL_ARRAY_UNIT_OF_INDEX, sizeof(void *));
        LVA1->ObjIndexSize = VL_ARRAY_UNIT_OF_INDEX;
    }
    else{//gAK͋
        ;
    }

    return VL_ARRAY_OK;
}

//====================================================================================================================
int VLArraySwap(VLArray *VLA, int Position0, int Position1)
//====================================================================================================================
// [@\] Position0ObjectPosition1Objectւ
// [] VLArray *VLAFϒz
// [] int *Position0 FΏۃoʒu
// [] int *Position1 FΏۃoʒu
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
{
    void                *Temp;

    if(VLA == NULL) return VL_ARRAY_NG;
    if(Position0 >= VLA->NumOfMember) return VL_ARRAY_NG;
    if(Position1 >= VLA->NumOfMember) return VL_ARRAY_NG;

    Temp = (VLA->ObjIndex)[Position0];
    (VLA->ObjIndex)[Position0] = (VLA->ObjIndex)[Position1];
    (VLA->ObjIndex)[Position1] = Temp;

    return VL_ARRAY_OK;
}

//====================================================================================================================
int VLArrayNumOfMemberGet(VLArray *VLA)
//====================================================================================================================
// [@\] ݂̗vfԂ
// [] VLArray *VLAFϒz
// [Ԓl] sVL_ARRAY_NGAA0ȏ̒lԂB
{
    if(VLA == NULL) return VL_ARRAY_NG;
    else            return VLA->NumOfMember;
}
