﻿//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  FUNCTION      : Debugger
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Psm3Debugger
{
    public partial class CodeBox : UserControl
    {
        //================================================================================================
        //=　定数宣言
        //================================================================================================
        public const uint P3DBG_OK = 0;
        public const uint P3DBG_NG = 1;
        public const uint P3DBG_ILG = 0xFFFFFFFF;
        public const uint SRC_MODE = 0;
        public const uint IASM_MODE = 1;
        public const uint SCROLL_UP = 0;
        public const uint SCROLL_DOWN = 1;
        //================================================================================================
        //=　変数宣言
        //================================================================================================
        public uint Mode = IASM_MODE;
        public uint TopIndex = 0;
        public uint TopIndexOffset = 0;
        public uint TopAddress = 0;
        public uint TopAddressOffset = 0;
        public uint ScrollFlag = 0;
        public uint ScrollValue;
        public uint ScrollUpDwn;
        public uint BreakChangeFlag = 0;
        public uint BreakChangeIndex = 0;
        public uint ProcessorNo = 0;
        public uint JumpFlag = 0;

        //=　コンストラクタ =================================
        public CodeBox()
        {
            InitializeComponent();
            Mode = IASM_MODE;
            ScrollFlag = 0;
            BreakChangeFlag = 0;
        }

        //=　共通関数[GUI更新] =================================
        public uint UpDateCodeWindow(uint PC, uint Bubble, ref uint[] BrkTbl, ref uint[] AdrTbl, ref uint[] HexTbl, ref string[] CodeTbl)
        {
            //==============[0] ================================
            if (BrkTbl[0] != 0) BreakLine0.Text = "●";
            else BreakLine0.Text = "";
            if (AdrTbl[0] != P3DBG_ILG) AdrLine0.Text = String.Format("{0:X8}", AdrTbl[0]);
            else AdrLine0.Text = "";
            if (AdrTbl[0] != P3DBG_ILG) HexLine0.Text = String.Format("{0:X8}", HexTbl[0]);
            else HexLine0.Text = "";
            CodeLine0.Text = CodeTbl[0];
            if (AdrTbl[0] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine0.BackColor = System.Drawing.Color.Yellow;
                    AdrLine0.BackColor = System.Drawing.Color.Yellow;
                    HexLine0.BackColor = System.Drawing.Color.Yellow;
                    CodeLine0.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine0.BackColor = System.Drawing.Color.Gray;
                    AdrLine0.BackColor = System.Drawing.Color.Gray;
                    HexLine0.BackColor = System.Drawing.Color.Gray;
                    CodeLine0.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine0.BackColor = System.Drawing.Color.White;
                AdrLine0.BackColor = System.Drawing.Color.White;
                HexLine0.BackColor = System.Drawing.Color.White;
                CodeLine0.BackColor = System.Drawing.Color.White;
            }

            //==============[1] ================================
            if (BrkTbl[1] != 0) BreakLine1.Text = "●";
            else BreakLine1.Text = "";
            if (AdrTbl[1] != P3DBG_ILG) AdrLine1.Text = String.Format("{0:X8}", AdrTbl[1]);
            else AdrLine1.Text = "";
            if (AdrTbl[1] != P3DBG_ILG) HexLine1.Text = String.Format("{0:X8}", HexTbl[1]);
            else HexLine1.Text = "";
            CodeLine1.Text = CodeTbl[1];
            if (AdrTbl[1] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine1.BackColor = System.Drawing.Color.Yellow;
                    AdrLine1.BackColor = System.Drawing.Color.Yellow;
                    HexLine1.BackColor = System.Drawing.Color.Yellow;
                    CodeLine1.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine1.BackColor = System.Drawing.Color.Gray;
                    AdrLine1.BackColor = System.Drawing.Color.Gray;
                    HexLine1.BackColor = System.Drawing.Color.Gray;
                    CodeLine1.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine1.BackColor = System.Drawing.Color.White;
                AdrLine1.BackColor = System.Drawing.Color.White;
                HexLine1.BackColor = System.Drawing.Color.White;
                CodeLine1.BackColor = System.Drawing.Color.White;
            }

            //==============[2] ================================
            if (BrkTbl[2] != 0) BreakLine2.Text = "●";
            else BreakLine2.Text = "";
            if (AdrTbl[2] != P3DBG_ILG) AdrLine2.Text = String.Format("{0:X8}", AdrTbl[2]);
            else AdrLine2.Text = "";
            if (AdrTbl[2] != P3DBG_ILG) HexLine2.Text = String.Format("{0:X8}", HexTbl[2]);
            else HexLine2.Text = "";
            CodeLine2.Text = CodeTbl[2];
            if (AdrTbl[2] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine2.BackColor = System.Drawing.Color.Yellow;
                    AdrLine2.BackColor = System.Drawing.Color.Yellow;
                    HexLine2.BackColor = System.Drawing.Color.Yellow;
                    CodeLine2.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine2.BackColor = System.Drawing.Color.Gray;
                    AdrLine2.BackColor = System.Drawing.Color.Gray;
                    HexLine2.BackColor = System.Drawing.Color.Gray;
                    CodeLine2.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine2.BackColor = System.Drawing.Color.White;
                AdrLine2.BackColor = System.Drawing.Color.White;
                HexLine2.BackColor = System.Drawing.Color.White;
                CodeLine2.BackColor = System.Drawing.Color.White;
            }

            //==============[3] ================================
            if (BrkTbl[3] != 0) BreakLine3.Text = "●";
            else BreakLine3.Text = "";
            if (AdrTbl[3] != P3DBG_ILG) AdrLine3.Text = String.Format("{0:X8}", AdrTbl[3]);
            else AdrLine3.Text = "";
            if (AdrTbl[3] != P3DBG_ILG) HexLine3.Text = String.Format("{0:X8}", HexTbl[3]);
            else HexLine3.Text = "";
            CodeLine3.Text = CodeTbl[3];
            if (AdrTbl[3] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine3.BackColor = System.Drawing.Color.Yellow;
                    AdrLine3.BackColor = System.Drawing.Color.Yellow;
                    HexLine3.BackColor = System.Drawing.Color.Yellow;
                    CodeLine3.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine3.BackColor = System.Drawing.Color.Gray;
                    AdrLine3.BackColor = System.Drawing.Color.Gray;
                    HexLine3.BackColor = System.Drawing.Color.Gray;
                    CodeLine3.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine3.BackColor = System.Drawing.Color.White;
                AdrLine3.BackColor = System.Drawing.Color.White;
                HexLine3.BackColor = System.Drawing.Color.White;
                CodeLine3.BackColor = System.Drawing.Color.White;
            }

            //==============[4] ================================
            if (BrkTbl[4] != 0) BreakLine4.Text = "●";
            else BreakLine4.Text = "";
            if (AdrTbl[4] != P3DBG_ILG) AdrLine4.Text = String.Format("{0:X8}", AdrTbl[4]);
            else AdrLine4.Text = "";
            if (AdrTbl[4] != P3DBG_ILG) HexLine4.Text = String.Format("{0:X8}", HexTbl[4]);
            else HexLine4.Text = "";
            CodeLine4.Text = CodeTbl[4];
            if (AdrTbl[4] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine4.BackColor = System.Drawing.Color.Yellow;
                    AdrLine4.BackColor = System.Drawing.Color.Yellow;
                    HexLine4.BackColor = System.Drawing.Color.Yellow;
                    CodeLine4.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine4.BackColor = System.Drawing.Color.Gray;
                    AdrLine4.BackColor = System.Drawing.Color.Gray;
                    HexLine4.BackColor = System.Drawing.Color.Gray;
                    CodeLine4.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine4.BackColor = System.Drawing.Color.White;
                AdrLine4.BackColor = System.Drawing.Color.White;
                HexLine4.BackColor = System.Drawing.Color.White;
                CodeLine4.BackColor = System.Drawing.Color.White;
            }

            //==============[5] ================================
            if (BrkTbl[5] != 0) BreakLine5.Text = "●";
            else BreakLine5.Text = "";
            if (AdrTbl[5] != P3DBG_ILG) AdrLine5.Text = String.Format("{0:X8}", AdrTbl[5]);
            else AdrLine5.Text = "";
            if (AdrTbl[5] != P3DBG_ILG) HexLine5.Text = String.Format("{0:X8}", HexTbl[5]);
            else HexLine5.Text = "";
            CodeLine5.Text = CodeTbl[5];
            if (AdrTbl[5] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine5.BackColor = System.Drawing.Color.Yellow;
                    AdrLine5.BackColor = System.Drawing.Color.Yellow;
                    HexLine5.BackColor = System.Drawing.Color.Yellow;
                    CodeLine5.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine5.BackColor = System.Drawing.Color.Gray;
                    AdrLine5.BackColor = System.Drawing.Color.Gray;
                    HexLine5.BackColor = System.Drawing.Color.Gray;
                    CodeLine5.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine5.BackColor = System.Drawing.Color.White;
                AdrLine5.BackColor = System.Drawing.Color.White;
                HexLine5.BackColor = System.Drawing.Color.White;
                CodeLine5.BackColor = System.Drawing.Color.White;
            }

            //==============[6] ================================
            if (BrkTbl[6] != 0) BreakLine6.Text = "●";
            else BreakLine6.Text = "";
            if (AdrTbl[6] != P3DBG_ILG) AdrLine6.Text = String.Format("{0:X8}", AdrTbl[6]);
            else AdrLine6.Text = "";
            if (AdrTbl[6] != P3DBG_ILG) HexLine6.Text = String.Format("{0:X8}", HexTbl[6]);
            else HexLine6.Text = "";
            CodeLine6.Text = CodeTbl[6];
            if (AdrTbl[6] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine6.BackColor = System.Drawing.Color.Yellow;
                    AdrLine6.BackColor = System.Drawing.Color.Yellow;
                    HexLine6.BackColor = System.Drawing.Color.Yellow;
                    CodeLine6.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine6.BackColor = System.Drawing.Color.Gray;
                    AdrLine6.BackColor = System.Drawing.Color.Gray;
                    HexLine6.BackColor = System.Drawing.Color.Gray;
                    CodeLine6.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine6.BackColor = System.Drawing.Color.White;
                AdrLine6.BackColor = System.Drawing.Color.White;
                HexLine6.BackColor = System.Drawing.Color.White;
                CodeLine6.BackColor = System.Drawing.Color.White;
            }

            //==============[7] ================================
            if (BrkTbl[7] != 0) BreakLine7.Text = "●";
            else BreakLine7.Text = "";
            if (AdrTbl[7] != P3DBG_ILG) AdrLine7.Text = String.Format("{0:X8}", AdrTbl[7]);
            else AdrLine7.Text = "";
            if (AdrTbl[7] != P3DBG_ILG) HexLine7.Text = String.Format("{0:X8}", HexTbl[7]);
            else HexLine7.Text = "";
            CodeLine7.Text = CodeTbl[7];
            if (AdrTbl[7] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine7.BackColor = System.Drawing.Color.Yellow;
                    AdrLine7.BackColor = System.Drawing.Color.Yellow;
                    HexLine7.BackColor = System.Drawing.Color.Yellow;
                    CodeLine7.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine7.BackColor = System.Drawing.Color.Gray;
                    AdrLine7.BackColor = System.Drawing.Color.Gray;
                    HexLine7.BackColor = System.Drawing.Color.Gray;
                    CodeLine7.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine7.BackColor = System.Drawing.Color.White;
                AdrLine7.BackColor = System.Drawing.Color.White;
                HexLine7.BackColor = System.Drawing.Color.White;
                CodeLine7.BackColor = System.Drawing.Color.White;
            }

            //==============[8] ================================
            if (BrkTbl[8] != 0) BreakLine8.Text = "●";
            else BreakLine8.Text = "";
            if (AdrTbl[8] != P3DBG_ILG) AdrLine8.Text = String.Format("{0:X8}", AdrTbl[8]);
            else AdrLine8.Text = "";
            if (AdrTbl[8] != P3DBG_ILG) HexLine8.Text = String.Format("{0:X8}", HexTbl[8]);
            else HexLine8.Text = "";
            CodeLine8.Text = CodeTbl[8];
            if (AdrTbl[8] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine8.BackColor = System.Drawing.Color.Yellow;
                    AdrLine8.BackColor = System.Drawing.Color.Yellow;
                    HexLine8.BackColor = System.Drawing.Color.Yellow;
                    CodeLine8.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine8.BackColor = System.Drawing.Color.Gray;
                    AdrLine8.BackColor = System.Drawing.Color.Gray;
                    HexLine8.BackColor = System.Drawing.Color.Gray;
                    CodeLine8.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine8.BackColor = System.Drawing.Color.White;
                AdrLine8.BackColor = System.Drawing.Color.White;
                HexLine8.BackColor = System.Drawing.Color.White;
                CodeLine8.BackColor = System.Drawing.Color.White;
            }

            //==============[9] ================================
            if (BrkTbl[9] != 0) BreakLine9.Text = "●";
            else BreakLine9.Text = "";
            if (AdrTbl[9] != P3DBG_ILG) AdrLine9.Text = String.Format("{0:X8}", AdrTbl[9]);
            else AdrLine9.Text = "";
            if (AdrTbl[9] != P3DBG_ILG) HexLine9.Text = String.Format("{0:X8}", HexTbl[9]);
            else HexLine9.Text = "";
            CodeLine9.Text = CodeTbl[9];
            if (AdrTbl[9] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine9.BackColor = System.Drawing.Color.Yellow;
                    AdrLine9.BackColor = System.Drawing.Color.Yellow;
                    HexLine9.BackColor = System.Drawing.Color.Yellow;
                    CodeLine9.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine9.BackColor = System.Drawing.Color.Gray;
                    AdrLine9.BackColor = System.Drawing.Color.Gray;
                    HexLine9.BackColor = System.Drawing.Color.Gray;
                    CodeLine9.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine9.BackColor = System.Drawing.Color.White;
                AdrLine9.BackColor = System.Drawing.Color.White;
                HexLine9.BackColor = System.Drawing.Color.White;
                CodeLine9.BackColor = System.Drawing.Color.White;
            }

            //==============[10] ================================
            if (BrkTbl[10] != 0) BreakLine10.Text = "●";
            else BreakLine10.Text = "";
            if (AdrTbl[10] != P3DBG_ILG) AdrLine10.Text = String.Format("{0:X8}", AdrTbl[10]);
            else AdrLine10.Text = "";
            if (AdrTbl[10] != P3DBG_ILG) HexLine10.Text = String.Format("{0:X8}", HexTbl[10]);
            else HexLine10.Text = "";
            CodeLine10.Text = CodeTbl[10];
            if (AdrTbl[10] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine10.BackColor = System.Drawing.Color.Yellow;
                    AdrLine10.BackColor = System.Drawing.Color.Yellow;
                    HexLine10.BackColor = System.Drawing.Color.Yellow;
                    CodeLine10.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine10.BackColor = System.Drawing.Color.Gray;
                    AdrLine10.BackColor = System.Drawing.Color.Gray;
                    HexLine10.BackColor = System.Drawing.Color.Gray;
                    CodeLine10.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine10.BackColor = System.Drawing.Color.White;
                AdrLine10.BackColor = System.Drawing.Color.White;
                HexLine10.BackColor = System.Drawing.Color.White;
                CodeLine10.BackColor = System.Drawing.Color.White;
            }

            //==============[11] ================================
            if (BrkTbl[11] != 0) BreakLine11.Text = "●";
            else BreakLine11.Text = "";
            if (AdrTbl[11] != P3DBG_ILG) AdrLine11.Text = String.Format("{0:X8}", AdrTbl[11]);
            else AdrLine11.Text = "";
            if (AdrTbl[11] != P3DBG_ILG) HexLine11.Text = String.Format("{0:X8}", HexTbl[11]);
            else HexLine11.Text = "";
            CodeLine11.Text = CodeTbl[11];
            if (AdrTbl[11] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine11.BackColor = System.Drawing.Color.Yellow;
                    AdrLine11.BackColor = System.Drawing.Color.Yellow;
                    HexLine11.BackColor = System.Drawing.Color.Yellow;
                    CodeLine11.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine11.BackColor = System.Drawing.Color.Gray;
                    AdrLine11.BackColor = System.Drawing.Color.Gray;
                    HexLine11.BackColor = System.Drawing.Color.Gray;
                    CodeLine11.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine11.BackColor = System.Drawing.Color.White;
                AdrLine11.BackColor = System.Drawing.Color.White;
                HexLine11.BackColor = System.Drawing.Color.White;
                CodeLine11.BackColor = System.Drawing.Color.White;
            }

            //==============[12] ================================
            if (BrkTbl[12] != 0) BreakLine12.Text = "●";
            else BreakLine12.Text = "";
            if (AdrTbl[12] != P3DBG_ILG) AdrLine12.Text = String.Format("{0:X8}", AdrTbl[12]);
            else AdrLine12.Text = "";
            if (AdrTbl[12] != P3DBG_ILG) HexLine12.Text = String.Format("{0:X8}", HexTbl[12]);
            else HexLine12.Text = "";
            CodeLine12.Text = CodeTbl[12];
            if (AdrTbl[12] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine12.BackColor = System.Drawing.Color.Yellow;
                    AdrLine12.BackColor = System.Drawing.Color.Yellow;
                    HexLine12.BackColor = System.Drawing.Color.Yellow;
                    CodeLine12.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine12.BackColor = System.Drawing.Color.Gray;
                    AdrLine12.BackColor = System.Drawing.Color.Gray;
                    HexLine12.BackColor = System.Drawing.Color.Gray;
                    CodeLine12.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine12.BackColor = System.Drawing.Color.White;
                AdrLine12.BackColor = System.Drawing.Color.White;
                HexLine12.BackColor = System.Drawing.Color.White;
                CodeLine12.BackColor = System.Drawing.Color.White;
            }

            //==============[13] ================================
            if (BrkTbl[13] != 0) BreakLine13.Text = "●";
            else BreakLine13.Text = "";
            if (AdrTbl[13] != P3DBG_ILG) AdrLine13.Text = String.Format("{0:X8}", AdrTbl[13]);
            else AdrLine13.Text = "";
            if (AdrTbl[13] != P3DBG_ILG) HexLine13.Text = String.Format("{0:X8}", HexTbl[13]);
            else HexLine13.Text = "";
            CodeLine13.Text = CodeTbl[13];
            if (AdrTbl[13] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine13.BackColor = System.Drawing.Color.Yellow;
                    AdrLine13.BackColor = System.Drawing.Color.Yellow;
                    HexLine13.BackColor = System.Drawing.Color.Yellow;
                    CodeLine13.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine13.BackColor = System.Drawing.Color.Gray;
                    AdrLine13.BackColor = System.Drawing.Color.Gray;
                    HexLine13.BackColor = System.Drawing.Color.Gray;
                    CodeLine13.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine13.BackColor = System.Drawing.Color.White;
                AdrLine13.BackColor = System.Drawing.Color.White;
                HexLine13.BackColor = System.Drawing.Color.White;
                CodeLine13.BackColor = System.Drawing.Color.White;
            }

            //==============[14] ================================
            if (BrkTbl[14] != 0) BreakLine14.Text = "●";
            else BreakLine14.Text = "";
            if (AdrTbl[14] != P3DBG_ILG) AdrLine14.Text = String.Format("{0:X8}", AdrTbl[14]);
            else AdrLine14.Text = "";
            if (AdrTbl[14] != P3DBG_ILG) HexLine14.Text = String.Format("{0:X8}", HexTbl[14]);
            else HexLine14.Text = "";
            CodeLine14.Text = CodeTbl[14];
            if (AdrTbl[14] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine14.BackColor = System.Drawing.Color.Yellow;
                    AdrLine14.BackColor = System.Drawing.Color.Yellow;
                    HexLine14.BackColor = System.Drawing.Color.Yellow;
                    CodeLine14.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine14.BackColor = System.Drawing.Color.Gray;
                    AdrLine14.BackColor = System.Drawing.Color.Gray;
                    HexLine14.BackColor = System.Drawing.Color.Gray;
                    CodeLine14.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine14.BackColor = System.Drawing.Color.White;
                AdrLine14.BackColor = System.Drawing.Color.White;
                HexLine14.BackColor = System.Drawing.Color.White;
                CodeLine14.BackColor = System.Drawing.Color.White;
            }

            //==============[15] ================================
            if (BrkTbl[15] != 0) BreakLine15.Text = "●";
            else BreakLine15.Text = "";
            if (AdrTbl[15] != P3DBG_ILG) AdrLine15.Text = String.Format("{0:X8}", AdrTbl[15]);
            else AdrLine15.Text = "";
            if (AdrTbl[15] != P3DBG_ILG) HexLine15.Text = String.Format("{0:X8}", HexTbl[15]);
            else HexLine15.Text = "";
            CodeLine15.Text = CodeTbl[15];
            if (AdrTbl[15] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine15.BackColor = System.Drawing.Color.Yellow;
                    AdrLine15.BackColor = System.Drawing.Color.Yellow;
                    HexLine15.BackColor = System.Drawing.Color.Yellow;
                    CodeLine15.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine15.BackColor = System.Drawing.Color.Gray;
                    AdrLine15.BackColor = System.Drawing.Color.Gray;
                    HexLine15.BackColor = System.Drawing.Color.Gray;
                    CodeLine15.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine15.BackColor = System.Drawing.Color.White;
                AdrLine15.BackColor = System.Drawing.Color.White;
                HexLine15.BackColor = System.Drawing.Color.White;
                CodeLine15.BackColor = System.Drawing.Color.White;
            }

            //==============[16] ================================
            if (BrkTbl[16] != 0) BreakLine16.Text = "●";
            else BreakLine16.Text = "";
            if (AdrTbl[16] != P3DBG_ILG) AdrLine16.Text = String.Format("{0:X8}", AdrTbl[16]);
            else AdrLine16.Text = "";
            if (AdrTbl[16] != P3DBG_ILG) HexLine16.Text = String.Format("{0:X8}", HexTbl[16]);
            else HexLine16.Text = "";
            CodeLine16.Text = CodeTbl[16];
            if (AdrTbl[16] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine16.BackColor = System.Drawing.Color.Yellow;
                    AdrLine16.BackColor = System.Drawing.Color.Yellow;
                    HexLine16.BackColor = System.Drawing.Color.Yellow;
                    CodeLine16.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine16.BackColor = System.Drawing.Color.Gray;
                    AdrLine16.BackColor = System.Drawing.Color.Gray;
                    HexLine16.BackColor = System.Drawing.Color.Gray;
                    CodeLine16.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine16.BackColor = System.Drawing.Color.White;
                AdrLine16.BackColor = System.Drawing.Color.White;
                HexLine16.BackColor = System.Drawing.Color.White;
                CodeLine16.BackColor = System.Drawing.Color.White;
            }

            //==============[17] ================================
            if (BrkTbl[17] != 0) BreakLine17.Text = "●";
            else BreakLine17.Text = "";
            if (AdrTbl[17] != P3DBG_ILG) AdrLine17.Text = String.Format("{0:X8}", AdrTbl[17]);
            else AdrLine17.Text = "";
            if (AdrTbl[17] != P3DBG_ILG) HexLine17.Text = String.Format("{0:X8}", HexTbl[17]);
            else HexLine17.Text = "";
            CodeLine17.Text = CodeTbl[17];
            if (AdrTbl[17] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine17.BackColor = System.Drawing.Color.Yellow;
                    AdrLine17.BackColor = System.Drawing.Color.Yellow;
                    HexLine17.BackColor = System.Drawing.Color.Yellow;
                    CodeLine17.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine17.BackColor = System.Drawing.Color.Gray;
                    AdrLine17.BackColor = System.Drawing.Color.Gray;
                    HexLine17.BackColor = System.Drawing.Color.Gray;
                    CodeLine17.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine17.BackColor = System.Drawing.Color.White;
                AdrLine17.BackColor = System.Drawing.Color.White;
                HexLine17.BackColor = System.Drawing.Color.White;
                CodeLine17.BackColor = System.Drawing.Color.White;
            }

            //==============[18] ================================
            if (BrkTbl[18] != 0) BreakLine18.Text = "●";
            else BreakLine18.Text = "";
            if (AdrTbl[18] != P3DBG_ILG) AdrLine18.Text = String.Format("{0:X8}", AdrTbl[18]);
            else AdrLine18.Text = "";
            if (AdrTbl[18] != P3DBG_ILG) HexLine18.Text = String.Format("{0:X8}", HexTbl[18]);
            else HexLine18.Text = "";
            CodeLine18.Text = CodeTbl[18];
            if (AdrTbl[18] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine18.BackColor = System.Drawing.Color.Yellow;
                    AdrLine18.BackColor = System.Drawing.Color.Yellow;
                    HexLine18.BackColor = System.Drawing.Color.Yellow;
                    CodeLine18.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine18.BackColor = System.Drawing.Color.Gray;
                    AdrLine18.BackColor = System.Drawing.Color.Gray;
                    HexLine18.BackColor = System.Drawing.Color.Gray;
                    CodeLine18.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine18.BackColor = System.Drawing.Color.White;
                AdrLine18.BackColor = System.Drawing.Color.White;
                HexLine18.BackColor = System.Drawing.Color.White;
                CodeLine18.BackColor = System.Drawing.Color.White;
            }

            //==============[19] ================================
            if (BrkTbl[19] != 0) BreakLine19.Text = "●";
            else BreakLine19.Text = "";
            if (AdrTbl[19] != P3DBG_ILG) AdrLine19.Text = String.Format("{0:X8}", AdrTbl[19]);
            else AdrLine19.Text = "";
            if (AdrTbl[19] != P3DBG_ILG) HexLine19.Text = String.Format("{0:X8}", HexTbl[19]);
            else HexLine19.Text = "";
            CodeLine19.Text = CodeTbl[19];
            if (AdrTbl[19] == PC)
            {
                if (Bubble == 0)
                {
                    BreakLine19.BackColor = System.Drawing.Color.Yellow;
                    AdrLine19.BackColor = System.Drawing.Color.Yellow;
                    HexLine19.BackColor = System.Drawing.Color.Yellow;
                    CodeLine19.BackColor = System.Drawing.Color.Yellow;
                }
                else
                {
                    BreakLine19.BackColor = System.Drawing.Color.Gray;
                    AdrLine19.BackColor = System.Drawing.Color.Gray;
                    HexLine19.BackColor = System.Drawing.Color.Gray;
                    CodeLine19.BackColor = System.Drawing.Color.Gray;
                }
            }
            else
            {
                BreakLine19.BackColor = System.Drawing.Color.White;
                AdrLine19.BackColor = System.Drawing.Color.White;
                HexLine19.BackColor = System.Drawing.Color.White;
                CodeLine19.BackColor = System.Drawing.Color.White;
            }

            return P3DBG_OK;
        }

        //=　ユーザー操作（Breakはり） =================================
        private void BreakLine0_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 0;
        }
        private void BreakLine1_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 1;
        }
        private void BreakLine2_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 2;
        }
        private void BreakLine3_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 3;
        }
        private void BreakLine4_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 4;
        }
        private void BreakLine5_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 5;
        }
        private void BreakLine6_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 6;
        }
        private void BreakLine7_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 7;
        }
        private void BreakLine8_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 8;
        }
        private void BreakLine9_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 9;
        }
        private void BreakLine10_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 10;
        }
        private void BreakLine11_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 11;
        }
        private void BreakLine12_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 12;
        }
        private void BreakLine13_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 13;
        }
        private void BreakLine14_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 14;
        }
        private void BreakLine15_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 15;
        }
        private void BreakLine16_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 16;
        }
        private void BreakLine17_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 17;
        }
        private void BreakLine18_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 18;
        }
        private void BreakLine19_DoubleClick(object sender, EventArgs e)
        {
            BreakChangeFlag = 1;
            BreakChangeIndex = 19;
        }


        //=　ユーザー操作（JUMPボタン） =================================
        private void JumpBtn_Click(object sender, EventArgs e)
        {
            JumpFlag = 1;
        }

        //=　ユーザー操作（スクロールバー） =================================
        private void vScrollBar1_ValueChanged(object sender, EventArgs e)
        {
            FoceScroll();
        }

        //=　ユーザー操作（強制スクロール） =================================
        public void FoceScroll()
        {
            if (Mode == SRC_MODE)
            {
                if ((uint)vScrollBar1.Value > TopIndex)
                {
                    ScrollValue = (uint)vScrollBar1.Value - TopIndex;
                    ScrollUpDwn = SCROLL_UP;
                }
                else
                {
                    ScrollValue = TopIndex - (uint)vScrollBar1.Value;
                    ScrollUpDwn = SCROLL_DOWN;
                }
            }
            else
            {
                if ((uint)vScrollBar1.Value > (TopAddress / 4))
                {
                    ScrollValue = (uint)vScrollBar1.Value - (TopAddress / 4);
                    ScrollUpDwn = SCROLL_UP;
                }
                else
                {
                    ScrollValue = (TopAddress / 4) - (uint)vScrollBar1.Value;
                    ScrollUpDwn = SCROLL_DOWN;
                }
            }
            ScrollFlag = 1;
        }

        //=　ユーザー操作（スクロールボタン） =================================
        /*
        private void Dwn1Btn_Click(object sender, EventArgs e)
        {
            ScrollValue = 1;
            ScrollUpDwn = SCROLL_DOWN;
            ScrollFlag = 1;
        }
        private void Up1Btn_Click(object sender, EventArgs e)
        {
            ScrollValue = 1;
            ScrollUpDwn = SCROLL_UP;
            ScrollFlag = 1;
        }
        private void Dwn10Btn_Click(object sender, EventArgs e)
        {
            ScrollValue = 10;
            ScrollUpDwn = SCROLL_DOWN;
            ScrollFlag = 1;
        }
        private void Up10Btn_Click(object sender, EventArgs e)
        {
            ScrollValue = 10;
            ScrollUpDwn = SCROLL_UP;
            ScrollFlag = 1;
        }
        */

    }
}
