﻿//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  FUNCTION      : Debugger
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Psm3Debugger
{
    public partial class RegSetForm : Form
    {
        //================================================================================================
        //=　変数
        //================================================================================================
        public uint RegMode; // 0:NotRegister, 1:Register
        public uint RegNo;
        public uint RegVal;
        public uint ChangeFlag;

        //================================================================================================
        //=　コンストラクタ
        //================================================================================================
        public RegSetForm()
        {
            InitializeComponent();
            this.ChangeFlag = 0;
        }
        //================================================================================================
        //=　Formロード
        //================================================================================================
        private void RegSetForm_Load(object sender, EventArgs e)
        {

        }
        //================================================================================================
        //=　OKボタン
        //================================================================================================
        private void OkBtn_Click(object sender, EventArgs e)
        {
            Str2Num();
            if (RegMode != 0)
            {
                if (RegNo == 15) RegVal &= 0xFFFFFFFC;
            }
            this.Hide();
            this.ChangeFlag = 1;
        }
        //================================================================================================
        //=　CANSELボタン
        //================================================================================================
        private void CancelBtn_Click(object sender, EventArgs e)
        {
            this.Hide();
            //this.ChangeFlag = 1;
        }
        //================================================================================================
        //=　文字列を数値に変換
        //================================================================================================
        private uint Char2Num(byte a)
        {
            if ((a & 0xF0) == 0x30) return (uint)(a & 0xF);
            return (uint)((a + 9) & 0xF);
        }
        private void Str2Num()
        {
            uint Tmp;
            int Len;
            int i;
            byte[] Str = Encoding.ASCII.GetBytes(TextBox.Text);
            Len = Str.Length;
            if (Len > 2)
            {
                if ((Str[0] == '0') && (Str[1] == 'x'))
                {
                    Tmp = 0;
                    for (i = 2; i < Len; i++)
                    {
                        Tmp = Tmp << 4;
                        Tmp = Tmp | Char2Num(Str[i]);
                    }
                }
                else
                {
                    if (Str[0] == '-') Tmp = (uint)Convert.ToInt32(TextBox.Text);
                    else Tmp = Convert.ToUInt32(TextBox.Text);
                }
            }
            else
            {
                if (Str[0] == '-') Tmp = (uint)Convert.ToInt32(TextBox.Text);
                else Tmp = Convert.ToUInt32(TextBox.Text);
            }
            RegVal = Tmp;
        }

        //================================================================================================
        //=　フォームが閉じないようにする。
        //================================================================================================
        private void RegSetForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
        }
    }
}
